﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Crossrail.IMS.Common
{
    public class Constant
    {
        public static int[] PageSizes = new int[] {20, 50, 100};
        public const int DefaultPageSize = 20;
        public const string DropDownListPlaceHolder = "--select--";
	    public const int DefaultGridHeight = 400;


        public class UserManagementErrorCode
        {
            public const int UNKNOWN_ERROR = -99;
            public const int USER_ALREADY_ADDED = -1;
        }

        public class DataManagementCategoryName
        {
            public const string Directorate = "Directorate";
            public const string Theme = "Theme";
            public const string SubTheme = "SubTheme";
            public const string Area = "Area";
            public const string Stage = "Stage";
            public const string IRL = "IRL";
            public const string HowCanWeHelp = "HowCanWeHelp";
            public const string IndividualOrSharedInnovation = "IndividualOrSharedInnovation";
            public const string BenefitClearlyUnderstood = "BenefitClearlyUnderstood";
            public const string SuitablyDevelopedToShare = "SuitablyDevelopedToShare";
			public const string IdeaType = "IdeaType";
			public const string PrimaryBenefit = "PrimaryBenefit";
			public const string IdeaMaturity = "IdeaMaturity";
			public const string InnovationSource = "InnovationSource";
            public const string AssignedInnovationTeamMember = "AssignedInnovationTeamMember";           
        }

        public class DataManagementErrorCode
        {
            public const string ErrorMessageDuplicateName = "Data name should be unique for each record.";
            public const string ErrorMessageEmpty = "Data name cannot be empty.";
            public const string ErrorMessageMaxLength = "Data name exceed characters limit.";
            public const string ErrorItemIsNotExist = "This data has already been deleted.";
            public const string ErrorCanNotDelete = "This value is being referenced so cannot be deleted. To delete this value first update any innovation records (to not use this).";
        }

        public class InnovationDetailErrorCode
        {
            public const string ErrorMessageRequired = "Please input all the mandatory fields.";
            public const string ErrorMessageEmailInvalid = "Email is invalid.";
            public const string ErrorMessageMaximumLength = "Data value exceed {1} characters limit.";
            public const string ErrorMessageNumber = "Please input the number.";
            public const string ErrorMessageCurrency = "Please input the valid number. e.g: 123456.12";
        }

        public enum EnumDetailMode
        {
            ViewMode,
            EditMode,
            CreateMode

        }

        public class Role
        {
            public const string SystemAdministrator = "System Administrator";
            public const string InnovationTeam = "Innovation Team";
            public const string InnovationChampion = "Innovation Champion";
            public const string ReadOnly = "Read Only";
        }

        public class SessionVariables
        {
            public const string UserDisplayName = "UserDisplayName";
            public const string UserRole = "UserRole";
            public const string UserID = "UserId";
            public const string SessionID = "ASP.NET_SessionId";
        }
    }
}
