﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace Crossrail.IMS.Common
{
	public class FileUtilities
	{
		public static string FormatFileName(string fileName)
		{
			if (String.IsNullOrEmpty(fileName))
				return String.Empty;

			return DateTime.Now.ToString("yyyyMMddHHmm") + fileName;
		}

		public static string GetOriginalFilename(string filePath)
		{
			if (!String.IsNullOrEmpty(filePath))
			{
				return Path.GetFileName(filePath).Substring("yyyyMMddHHmm".Length);
			}
			
			return string.Empty;
		}

		public static bool DeleteFile(string filePath)
		{
			try
			{
				if (!String.IsNullOrEmpty(filePath) && File.Exists(filePath))
				{
					File.Delete(filePath);
				}
			}
			catch (Exception ex)
			{
				return false;
			}

			return true;
		}
	}
}
