﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;
using Crossrail.IMS.Common;
using Crossrail.IMS.DataGateway;
using Crossrail.IMS.DataGateway.Dtos;
using Crossrail.IMS.DataGateway.Entities;
using Crossrail.IMS.DataGateway.Repositories;
using Crossrail.IMS.DataGateway.Utilities;

namespace Crossrail.IMS.DataGateway
{
    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the class name "Service1" in code, svc and config file together.
    [ServiceBehavior(InstanceContextMode = InstanceContextMode.Single)]
    public class DataGatewayService : IDataGatewayService
    {
        public void AuditLoginUser(string userName)
        {
            using (MainContext context = new MainContext())
            {
                AuditLog auditLog = new AuditLog()
                {
                    UserName = userName,
                    EventDate = DateTime.Now,
                    EventType = "Logged-in",
                    TableName = "",
                    ColumnName = "",
                    RecordID = ""
                };


                context.SaveChanges(userName);
            }
        }

        /// <summary>
        /// The innovation data repository
        /// </summary>
        public IInnovationDataRepository InnovationDataRepository
        {
            get { return _innovationDataRepository ?? (_innovationDataRepository = new InnovationDataRepository()); }
        }

        /// <summary>
        /// The innovation data repository
        /// </summary>
        public InnovationData GetInnovationDataById(int id)
        {
            return InnovationDataRepository.GetInnovationDataById(id);
        }

        /// <summary>
        /// The sub theme repository
        /// </summary>
        public ISubThemeRepository SubThemeRepository
        {
            get { return _subThemeRepository ?? (_subThemeRepository = new SubThemeRepository()); }
        }

        /// <summary>
        /// The innovation repository
        /// </summary>
        public IImportInnovationRepository ImportInnovationRepository
        {
            get { return _importInnovationRepository ?? (_importInnovationRepository = new ImportInnovationRepository()); }
        }

        /// <summary>
        /// The _innovation data repository
        /// </summary>
        private InnovationDataRepository _innovationDataRepository;

        /// <summary>
        /// The _sub theme repository
        /// </summary>
        private ISubThemeRepository _subThemeRepository;

        /// <summary>
        /// The import Innovation repository
        /// </summary>
        private IImportInnovationRepository _importInnovationRepository;

        private IUserRepository _userRepository;
        public IUserRepository UserRepository
        {
            get
            {
                if (_userRepository == null)
                    _userRepository = new UserRepository();

                return _userRepository;
            }
        }

        private IInnovationRepository _innovationRepository;
        public IInnovationRepository InnovationRepository
        {
            get
            {
                if (_innovationRepository == null)
                    _innovationRepository = new InnovationRepository();


                return _innovationRepository;
            }
        }

        private IInnovationFinancialRepository _innovationFinancialRepository;
        public IInnovationFinancialRepository InnovationFinancialRepository
        {
            get
            {
                if (_innovationFinancialRepository == null)
                    _innovationFinancialRepository = new InnovationFinancialRepository();


                return _innovationFinancialRepository;
            }
        }

        /// <summary>
        /// The _sub report innovation repository
        /// </summary>
        private IReportInnovationRepository _reportInnovationRepository;

        public IReportInnovationRepository ReportInnovationRepository
        {
            get { return _reportInnovationRepository ?? (_reportInnovationRepository = new ReportInnovationRepository()); }
        }

        private IAttractivenessComplexityRepository _attractivenessComplexityRepository;
        public IAttractivenessComplexityRepository AttractivenessComplexityRepository
        {
            get
            {
                return _attractivenessComplexityRepository ?? (_attractivenessComplexityRepository = new AttractivenessComplexityRepository());
            }
        }

        private IInnovationProgressRepository _innovationProgressRepository;
        public IInnovationProgressRepository InnovationProgressRepository
        {
            get
            {
                return _innovationProgressRepository ?? (_innovationProgressRepository = new InnovationProgressRepository());
            }
        }

        private IPeopleSupportRepository _peopleSupportRepository;
        public IPeopleSupportRepository PeopleSupportRepository
        {
            get
            {
                return _peopleSupportRepository ?? (_peopleSupportRepository = new PeopleSupportRepository());
            }
        }

        private IPeopleSupportTempRepository _peopleSupportTempRepository;
        public IPeopleSupportTempRepository PeopleSupportTempRepository
        {
            get
            {
                return _peopleSupportTempRepository ?? (_peopleSupportTempRepository = new PeopleSupportTempRepository());
            }
        }

        private IActionsRequiredRepository _actionsRequiredRepository;
        public IActionsRequiredRepository ActionsRequiredRepository
        {
            get
            {
                return _actionsRequiredRepository ?? (_actionsRequiredRepository = new ActionsRequiredRepository());
            }
        }

        private IActionsRequiredRepositoryTemp _actionsRequiredRepositoryTemp;
        public IActionsRequiredRepositoryTemp ActionsRequiredRepositoryTemp
        {
            get
            {
                return _actionsRequiredRepositoryTemp ?? (_actionsRequiredRepositoryTemp = new ActionsRequiredRepositoryTemp());
            }
        }

        private IResourcesRequiredRepository _resourcesRequiredRepository;
        public IResourcesRequiredRepository ResourcesRequiredRepository
        {
            get
            {
                return _resourcesRequiredRepository ?? (_resourcesRequiredRepository = new ResourcesRequiredRepository());
            }
        }

        private IResourcesRequiredTempRepository _resourcesRequiredTempRepository;
        public IResourcesRequiredTempRepository ResourcesRequiredTempRepository
        {
            get
            {
                return _resourcesRequiredTempRepository ?? (_resourcesRequiredTempRepository = new ResourcesRequiredTempRepository());
            }
        }

        private IGetInnovationRepository _getInnovationRepository;
        public IGetInnovationRepository GetInnovationRepository
        {
            get
            {
                if (_getInnovationRepository == null)
                    _getInnovationRepository = new GetInnovationRepository();

                return _getInnovationRepository;
            }
        }

        private ISearchInnovationRepository _searchInnovationRepository;
        public ISearchInnovationRepository SearchInnovationRepository
        {
            get
            {
                if (_searchInnovationRepository == null)
                    _searchInnovationRepository = new SearchInnovationRepository();

                return _searchInnovationRepository;
            }
        }

        private ILinkedDocumentRepository _linkedDocumentRepository;
        public ILinkedDocumentRepository LinkedDocumentRepository
        {
            get
            {
                if (_linkedDocumentRepository == null)
                    _linkedDocumentRepository = new LinkedDocumentRepository();

                return _linkedDocumentRepository;
            }
        }

        private ILinkedDocumentsTemporaryRepository _linkedDocumentsTemporaryRepository;
        public ILinkedDocumentsTemporaryRepository LinkedDocumentsTemporaryRepository
        {
            get
            {
                if (_linkedDocumentsTemporaryRepository == null)
                    _linkedDocumentsTemporaryRepository = new LinkedDocumentsTemporaryRepository();

                return _linkedDocumentsTemporaryRepository;
            }
        }

        public string GetData(int value)
        {

            using (MainContext context = new MainContext())
            {
                SubTheme subTheme = new SubTheme();
                subTheme.InnovationData = new InnovationData { DataValue = "Data Value 2", Category = 2 };
                subTheme.DataValue = "Sub Theme 1";
                context.SubThemes.Add(subTheme);
                int isSave = context.SaveChanges();
            }

            return string.Format("You entered: {0}", value);
        }

        #region Innovation Data
        /// <summary>
        /// Adds the innovation data.
        /// </summary>
        /// <returns></returns>
        public int AddInnovationData(InnovationData innovationData, string userName)
        {
            return InnovationDataRepository.AddInnovationData(innovationData, userName);
        }

        /// <summary>
        /// Updates the innovation data.
        /// </summary>
        /// <returns></returns>
        public int UpdateInnovationData(InnovationData innovationData, string userName)
        {
            return InnovationDataRepository.UpdateInnovationData(innovationData, userName);
        }

        /// <summary>
        /// Deletes the innovation data.
        /// </summary>
        /// <returns></returns>
        public int DeleteInnovationData(int innovationDataId, string userName)
        {
            return InnovationDataRepository.DeleteInnovationData(innovationDataId, userName);
        }

        /// <summary>
        /// Gets the innovation data by category.
        /// </summary>
        /// <param name="category">The category.</param>
        /// <returns></returns>
        public List<InnovationData> GetInnovationDataByCategory(InnovationDataCategory category)
        {
            return InnovationDataRepository.GetInnovationDataByCategory(category);
        }

        /// <summary>
        /// Finds the specified id.
        /// </summary>
        /// <param name="id">The id.</param>
        /// <returns></returns>
        public InnovationData FindInnovationData(int id)
        {
            return InnovationDataRepository.Find(id);
        }

        public bool IsInnovationDataValueExist(int id, string dataValue, InnovationDataCategory category)
        {
            return InnovationDataRepository.IsInnovationDataValueExist(id, dataValue, category);
        }
        #endregion

        #region Sub Theme
        /// <summary>
        /// Adds the sub theme.
        /// </summary>
        /// <param name="subTheme">The sub theme.</param>
        /// <returns></returns>
        public int AddSubTheme(SubTheme subTheme, string userName)
        {
            return SubThemeRepository.AddSubTheme(subTheme, userName);
        }

        /// <summary>
        /// Updates the innovation data.
        /// </summary>
        /// <returns></returns>
        public int UpdateSubTheme(SubTheme subTheme, string userName)
        {
            return SubThemeRepository.UpdateSubTheme(subTheme, userName);
        }

        /// <summary>
        /// Deletes the innovation data.
        /// </summary>
        /// <returns></returns>
        public int DeleteSubTheme(int subThemeId, string userName)
        {
            return SubThemeRepository.DeleteSubTheme(subThemeId, userName);
        }

        /// <summary>
        /// Gets the innovation data by category.
        /// </summary>
        /// <returns></returns>
        public List<SubTheme> GetSubThemes()
        {
            return SubThemeRepository.GetSubThemes();
            //return new List<SubTheme>();
        }

        public bool IsSubThemeNameExist(int id, string dataValue)
        {
            return SubThemeRepository.IsSubThemeNameExist(id, dataValue);
        }

        public List<SubTheme> GetSubThemeByThemeID(int themeID)
        {
            return SubThemeRepository.GetSubThemeByThemeID(themeID);
        }

        /// <summary>
        /// Finds the sub theme.
        /// </summary>
        /// <param name="subThemeId">The sub theme id.</param>
        /// <returns></returns>
        public SubTheme FindSubTheme(int subThemeId)
        {
            return SubThemeRepository.FindSubTheme(subThemeId);
        }
        #endregion

        #region User

        /// <summary>
        /// Get all roles
        /// </summary>
        /// <returns></returns>
        public List<Role> GetAllRoles()
        {
            //return null;
            return UserRepository.GetAllRoles();
        }

        /// <summary>
        /// Add user to the system
        /// </summary>
        /// <param name="user"></param>
        /// <returns></returns>
        public int AddUser(User user, string userName)
        {
            return UserRepository.AddUser(user, userName);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public List<User> GetAllSystemUsers()
        {
            return UserRepository.GetAllSystemUsers();
        }

        /// <summary>
        /// Get user by userID
        /// </summary>
        /// <param name="userID"></param>
        /// <returns></returns>
        public User GetUser(int userID)
        {
            return UserRepository.GetUser(userID);
        }

        /// <summary>
        /// Update user
        /// </summary>
        /// <param name="user"></param>
        /// <returns></returns>
        public int UpdateUser(User user, string userName)
        {
            return UserRepository.UpdateUser(user, userName);
        }

        /// <summary>
        /// Check whether a user is valid or not
        /// </summary>
        /// <param name="userName"></param>
        /// <returns></returns>
        public bool IsValidUser(string userName)
        {
            return UserRepository.IsValidUser(userName);
        }

        /// <summary>
        /// Get user by username
        /// </summary>
        /// <param name="userName"></param>
        /// <returns></returns>
        public User GetUserByUserName(string userName)
        {
            return UserRepository.GetUser(userName);
        }
        #endregion

        #region AttractivenessComplexity

        public List<AttractivenessComplexity> GetAttractivenessComplexityByQuestionId(
            AttractivenessComplexityQuestionId questionId)
        {
            return AttractivenessComplexityRepository.GetAnswersByQuestionId(questionId);

        }

        #endregion

        #region Innovation Progress
        /// <summary>
        /// Creates the specified innovation progress.
        /// </summary>
        /// <param name="innovationProgress">The innovation progress.</param>
        /// <returns></returns>
        public int CreateInnovationProgress(InnovationProgress innovationProgress, string userName)
        {
            return InnovationProgressRepository.CreateInnovationProgress(innovationProgress, userName);
        }

        /// <summary>
        /// Updates the innovation progress.
        /// </summary>
        /// <param name="innovationProgress">The innovation progress.</param>
        /// <returns></returns>
        public int UpdateInnovationProgress(InnovationProgress innovationProgress, string userName)
        {
            return InnovationProgressRepository.UpdateInnovationProgress(innovationProgress, userName);
        }

        #region People Support

        public List<PeopleSupport> GetAllPeopleSupportByInnovationId(int innovationId)
        {
            return PeopleSupportRepository.GetAllPeopleSupportByInnovationId(innovationId);
        }


        //public int AddPeopleSupport(PeopleSupport peopleSupport, string userName)
        //{
        //    return PeopleSupportRepository.AddPeopleSupport(peopleSupport, userName);
        //}


        //public int UpdatePeopleSupport(PeopleSupport peopleSupport, string userName)
        //{
        //    return PeopleSupportRepository.UpdatePeopleSupport(peopleSupport, userName);
        //}


        //public int DeletePeopleSupport(int id, string userName)
        //{
        //    return PeopleSupportRepository.DeletePeopleSupport(id, userName);
        //}		
        #endregion

        #region Action Required
        public List<ActionsRequired> GetAllActionsRequiredByInnovationId(int innovationId)
        {
            return ActionsRequiredRepository.GetAllActionsRequiredByInnovationId(innovationId);
        }
        #endregion

        #region Resources Required
        public List<ResourcesRequired> GetAllResourcesRequiredByInnovationId(int innovationId)
        {
            return ResourcesRequiredRepository.GetAllResourcesRequiredByInnovationId(innovationId);
        }
        #endregion

        #region Actions Required Temporary
        public int AddActionsRequiredTemporary(ActionsRequiredTemporary actionsRequired, string userName)
        {
            return ActionsRequiredRepositoryTemp.AddActionsRequiredTemporary(actionsRequired, userName);
        }

        public int UpdateActionsRequiredTemporary(ActionsRequiredTemporary actionsRequired, string userName)
        {
            return ActionsRequiredRepositoryTemp.UpdateActionsRequiredTemporary(actionsRequired, userName);

        }

        public int DeleteActionsRequiredTemporary(int id, string userName)
        {
            return ActionsRequiredRepositoryTemp.DeleteActionsRequiredTemporary(id, userName);
        }

        public List<ActionsRequiredTemporary> GetAllActionsRequiredTemporaryByInnovationId(int innovationId, Guid temptId)
        {
            return ActionsRequiredRepositoryTemp.GetAllActionsRequiredTemporaryByInnovationId(innovationId, temptId);
        }

        public void FillActionsRequiredTemporaryByInnovationId(int innovationId)
        {
            ActionsRequiredRepositoryTemp.FillActionsRequiredTemporaryByInnovationId(innovationId);
        }

        public void CleanupActionsRequiredTemporaryByInnovationId(int innovationId)
        {
            ActionsRequiredRepositoryTemp.CleanupActionsRequiredTemporaryByInnovationId(innovationId);
        }

        public int SaveActionsRequired(int innovationId, string userName,
                                     List<ActionsRequiredTemporary> actionsRequiredTemporaryList)
        {
            return ActionsRequiredRepositoryTemp.SaveActionsRequired(innovationId, userName, actionsRequiredTemporaryList);
        }

        #endregion

        #region Resources Required Temporary
        public int AddResourcesRequiredTemporary(ResourcesRequiredTemporary resourcesRequired, string userName)
        {
            return ResourcesRequiredTempRepository.AddResourcesRequiredTemporary(resourcesRequired, userName);
        }

        public int UpdateResourcesRequiredTemporary(ResourcesRequiredTemporary resourcesRequired, string userName)
        {
            return ResourcesRequiredTempRepository.UpdateResourcesRequiredTemporary(resourcesRequired, userName);
        }

        public int DeleteResourcesRequiredTemporary(int id, string userName)
        {
            return ResourcesRequiredTempRepository.DeleteResourcesRequiredTemporary(id, userName);
        }

        public List<ResourcesRequiredTemporary> GetAllResourcesRequiredTemporaryByInnovationId(int innovationId, Guid temptId)
        {
            return ResourcesRequiredTempRepository.GetAllResourcesRequiredTemporaryByInnovationId(innovationId, temptId);
        }

        public void FillResourceRequiredTemporaryByInnovationId(int innovationId)
        {
            ResourcesRequiredTempRepository.FillResourceRequiredTemporaryByInnovationId(innovationId);
        }

        public void CleanupResourceRequiredTemporaryByInnovationId(int innovationId)
        {
            ResourcesRequiredTempRepository.CleanupResourceRequiredTemporaryByInnovationId(innovationId);
        }

        public int SaveResourcesRequired(int innovationId, string userName, List<ResourcesRequiredTemporary> resourcesRequiredTemporaryList)
        {
            return ResourcesRequiredTempRepository.SaveResourcesRequired(innovationId, userName, resourcesRequiredTemporaryList);
        }

        #endregion

        #region People Support Temporary
        public int AddPeopleSupportTemporary(PeopleSupportTemporary peopleSupport, string userName)
        {
            return PeopleSupportTempRepository.AddPeopleSupportTemporary(peopleSupport, userName);
        }

        public int UpdatePeopleSupportTemporary(PeopleSupportTemporary peopleSupport, string userName)
        {
            return PeopleSupportTempRepository.UpdatePeopleSupportTemporary(peopleSupport, userName);
        }

        public int DeletePeopleSupportTemporary(int id, string userName)
        {
            return PeopleSupportTempRepository.DeletePeopleSupportTemporary(id, userName);
        }

        public List<PeopleSupportTemporary> GetAllPeopleSupportTemporaryByInnovationId(int innovationId, Guid temptId)
        {
            return PeopleSupportTempRepository.GetAllPeopleSupportTemporaryByInnovationId(innovationId, temptId);
        }

        public void FillPeopleSupportTemporaryByInnovationId(int innovationId)
        {
            PeopleSupportTempRepository.FillPeopleSupportTemporaryByInnovationId(innovationId);
        }

        public void CleanupPeopleSupportTemporaryByInnovationId(int innovationId)
        {
            PeopleSupportTempRepository.CleanupPeopleSupportTemporaryByInnovationId(innovationId);
        }

        public int SavePeopleSupport(int innovationId, string userName, List<PeopleSupportTemporary> peopleSupportTemporaryList)
        {
            return PeopleSupportTempRepository.SavePeopleSupport(innovationId, userName, peopleSupportTemporaryList);
        }
        #endregion

        public AttractivenessComplexity GetAnswersById(int id)
        {
            return AttractivenessComplexityRepository.GetAnswersById(id);
        }

        #endregion

        #region Report
        /// <summary>
        /// Gets the innovation period name
        /// </summary>
        /// <returns></returns>
        public List<InnovationPeriod> GetInnovationPeriods(string filePath)
        {
            return ReportInnovationRepository.GetInnovationPeriods(filePath);
        }

        /// <summary>
        /// Gets the innovation period name
        /// </summary>
        /// <returns></returns>
        public List<DataNewSubmissionReport> exportNewSubmissionReport(IList<InnovationPeriod> periods)
        {
            return ReportInnovationRepository.exportNewSubmissionReport(periods);
        }

        /// <summary>
        /// Gets the innovation period name
        /// </summary>
        /// <returns></returns>
        public List<DataStageInnovationReport> exportStageSubmissionReport(IList<InnovationPeriod> periods)
        {
            return ReportInnovationRepository.exportStageSubmissionReport(periods);
        }

        /// <summary>
        /// Gets the innovation period name
        /// </summary>
        /// <returns></returns>
        public List<DataNewSubmissionReport> exportExtractSubmissionReport(IList<InnovationPeriod> periods)
        {
            return ReportInnovationRepository.exportExtractSubmissionReport(periods);
        }
        #endregion

        #region Innovation Details

        public Innovation GetInnovation(int innovationId)
        {
            return GetInnovationRepository.GetInnovation(innovationId);
        }

        public InnovationProgress GetInnovationProgress(int innovationId)
        {
            return InnovationProgressRepository.GetInnovationProgress(innovationId);
        }


        #endregion

        #region Innovation
        /// <summary>
        /// Creates the specified innovation .
        /// </summary>
        public int AddOnlineInnovation(Innovation innovation, string userName)
        {
            int innovationId = InnovationRepository.AddInnovation(innovation, userName);
            innovation.ID = innovationId;
            ////Create InnovationProgress
            //int innovationProgressId = InnovationProgressRepository.CreateInnovationProgress(new InnovationProgress() { Innovation = innovation, InnovationRef = innovation.InnovationRef }, userName);
            ////Innovation Innovation Finnancial
            //int innovationFinancialId = InnovationFinancialRepository.AddInnovationFinancial(new InnovationFinancial() { Innovation = innovation, InnovationRef = innovation.InnovationRef }, userName);

            return innovationId;
        }

        /// <summary>
        /// Get innovation by innovationID
        /// </summary>
        public Innovation GetOnlineInnovationById(int innovationId)
        {
            return InnovationRepository.GetInnovationById(innovationId);
        }

        /// <summary>
        /// Update innovation
        /// </summary>
        public int UpdateOnlineInnovation(Innovation innovation, string userName)
        {
            return InnovationRepository.UpdateInnovation(innovation, userName);
        }

        /// <summary>
        /// Delete innovation
        /// </summary>
        /// <param name="userName"></param>
        /// <returns></returns>
        public bool DeleteOnlineInnovation(int innovationId, string userName)
        {
            return InnovationRepository.DeleteInnovation(innovationId, userName);
        }

        /// <summary>
        /// Get all innovations
        /// </summary>
        /// <returns></returns>
        public List<Innovation> GetAllInnovations(string userName, int pageNumber, int pageSize, string sortColumn, string sortDir, out int total)
        {
            return InnovationRepository.GetAllInnovations(userName, pageNumber, pageSize, sortColumn, sortDir, out total);
        }

        /// <summary>
        /// Add Innovation
        /// </summary>
        /// <param name="innovation"></param>
        /// <returns></returns>
        public string AddInnovation(Innovation innovation, string userName)
        {
            return ImportInnovationRepository.AddInnovation(innovation, userName);
        }

        /// <summary>
        /// Update Innovation
        /// </summary>
        /// <param name="innovation"></param>
        /// <returns></returns>
        public int UpdateInnovation(Innovation innovation, string userName)
        {
            return ImportInnovationRepository.UpdateInnovation(innovation, userName);
        }

        /// <summary>
        /// Cancel Innovation
        /// </summary>
        public int CancelinnovationDetail(int innovationId, string innovationRef, string userName)
        {
            return InnovationRepository.CancelinnovationDetail(innovationId, innovationRef, userName);
        }
        #endregion

        #region Innovation Financial
        public int AddInnovationFinancial(InnovationFinancial innovationFinancial, string userName)
        {
            return InnovationFinancialRepository.AddInnovationFinancial(innovationFinancial, userName);
        }

        public InnovationFinancial GetInnovationFinancialById(int innovationFinancialId)
        {
            return InnovationFinancialRepository.GetInnovationFinancialById(innovationFinancialId);
        }

        public InnovationFinancial GetInnovationFinancialByInnovationId(int innovationId)
        {
            return InnovationFinancialRepository.GetInnovationFinancialByInnovationId(innovationId);
        }

        public int UpdateInnovationFinancial(InnovationFinancial innovationFinancial, string userName)
        {
            return InnovationFinancialRepository.UpdateInnovationFinancial(innovationFinancial, userName);
        }

        public bool DeleteInnovationFinancial(int innovationFinancialId, string userName)
        {
            return InnovationFinancialRepository.DeleteInnovationFinancial(innovationFinancialId, userName);
        }
        #endregion

        public string GetNextInnovationRef()
        {
            return CommonUtil.GetNextInnovationRef();
        }

        public List<Innovation> SearchInnovation(SearchInnovationCriteria criteria, string userName, int pageNumber, int pageSize, string sortColumn, string sortDir, out int total)
        {
            return SearchInnovationRepository.SearchInnovation(criteria, userName, pageNumber, pageSize, sortColumn, sortDir, out total);
        }
        public InnovationProgress GetInnovationProgressByInRef(string inRef)
        {
            return InnovationProgressRepository.GetInnovationProgressByInRef(inRef);
        }

        public InnovationFinancial GetInnovationFinancialByInRef(string inRef)
        {
            return InnovationFinancialRepository.GetInnovationFinancialByInRef(inRef);
        }

        public string GetContactEmailByRoleId(int roleId, int psdId)
        {
            return ImportInnovationRepository.GetContactEmailByRoleId(roleId, psdId);
        }

        public string GetContactEmailByPSDId(int psdId)
        {
            return ImportInnovationRepository.GetContactEmailByPSDId(psdId);
        }

        #region Linked Documents

        public int AddLinkedDocument(LinkedDocument linkedDocument, string userName)
        {
            return LinkedDocumentRepository.AddLinkedDocument(linkedDocument, userName);
        }

        public int UpdateLinkedDocument(LinkedDocument linkedDocument, string userName)
        {
            return LinkedDocumentRepository.UpdateLinkedDocument(linkedDocument, userName);
        }

        public int DeleteLinkedDocument(int id, string userName)
        {
            return LinkedDocumentRepository.DeleteLinkedDocument(id, userName);
        }

        public List<LinkedDocument> GetLinkedDocumentsByInnovationId(int innovationId)
        {
            return LinkedDocumentRepository.GetLinkedDocumentsByInnovationId(innovationId);
        }

        public LinkedDocument GetLinkedDocumentById(int id)
        {
            return LinkedDocumentRepository.GetLinkedDocumentById(id);
        }

        public void ResetDocumentStatus(int innovationId, string userName)
        {
            LinkedDocumentRepository.ResetDocumentStatus(innovationId, userName);
        }

        #endregion

        #region Link Document Temporary
        public int AddLinkedDocumentsTemporary(LinkedDocumentsTemporary linkDocument, string userName)
        {
            return LinkedDocumentsTemporaryRepository.AddLinkedDocumentsTemporary(linkDocument, userName);
        }

        public int UpdateLinkedDocumentsTemporary(LinkedDocumentsTemporary linkDocument, string userName)
        {
            return LinkedDocumentsTemporaryRepository.UpdateLinkedDocumentsTemporary(linkDocument, userName);
        }

        public int DeleteLinkedDocumentsTemporary(int id, string userName)
        {
            return LinkedDocumentsTemporaryRepository.DeleteLinkedDocumentsTemporary(id, userName);
        }

        public List<LinkedDocumentsTemporary> GetAllLinkedDocumentsTemporaryByInnovationId(int innovationId, Guid temptId)
        {
            return LinkedDocumentsTemporaryRepository.GetAllLinkedDocumentsTemporaryByInnovationId(innovationId, temptId);
        }

        public void FillLinkedDocumentsTemporaryByInnovationId(int innovationId)
        {
            LinkedDocumentsTemporaryRepository.FillLinkedDocumentsTemporaryByInnovationId(innovationId);
        }

        public void CleanupLinkedDocumentsTemporaryByInnovationId(int innovationId)
        {
            LinkedDocumentsTemporaryRepository.CleanupLinkedDocumentsTemporaryByInnovationId(innovationId);
        }

        public int SaveLinkedDocuments(int innovationId, string userName, List<LinkedDocumentsTemporary> linkedDocumentsTemporaryList)
        {
            return LinkedDocumentsTemporaryRepository.SaveLinkedDocuments(innovationId, userName, linkedDocumentsTemporaryList);
        }
        #endregion

        #region Remit

        public List<InnovationRemitImp> GetInnovationRemitImps(int innovationId)
        {
            return InnovationRepository.GetInnovationRemitImps(innovationId);
        }

        public List<InnovationRemitResponsible> GetInnovationRemitResponsibles(int innovationId)
        {
            return InnovationRepository.GetInnovationRemitResponsibles(innovationId);
        }

        public List<InnovationRemitSuccessFailure> GetInnovationRemitSuccessFailures(int innovationId)
        {
            return InnovationRepository.GetInnovationRemitSuccessFailures(innovationId);
        }

        public List<InnovationRemitAuthProceed> GetInnovationRemitAuthProceeds(int innovationId)
        {
            return InnovationRepository.GetInnovationRemitAuthProceeds(innovationId);
        }

        public List<InnovationRemitSuppoter> GetInnovationRemitSuppoters(int innovationId)
        {
            return InnovationRepository.GetInnovationRemitSuppoters(innovationId);
        }

        #endregion
    }
}
