﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Web;
using System.Runtime.Serialization;
using System.Data.SqlTypes;

namespace Crossrail.IMS.DataGateway
{
    [DataContract]
    public class InnovationFinancial
    {
        public InnovationFinancial()
        {
            Init();
        }

        /// <summary>
        /// Initialize default value for properties.
        /// </summary>
        private void Init()
        {
            this.IncifDelegatedAuthorityDate = SqlDateTime.MinValue.Value;
            this.DateofIA = SqlDateTime.MinValue.Value;
            this.DateofICSC = SqlDateTime.MinValue.Value;
            this.ExternalDelegatedAuthorityDate = SqlDateTime.MinValue.Value;
        }

        [System.Runtime.Serialization.OnDeserializing]
        private void OnDeserializing(StreamingContext ctx)
        {
            Init();
        }

        [DataMember]
        public int ID { get; set; }

        [DataMember]
        public Innovation Innovation { get; set; }

        [DataMember]
        public string InnovationRef { get; set; }

        [DataMember]
        public decimal? ExpenditureToDate { get; set; }

        [DataMember]
        public decimal TotalAuthorisedInvestment { get; set; }

        [DataMember]
        public decimal CRLAuthorisedInvestment { get; set; }

        [DataMember]
        public decimal TSLGFundsSecured { get; set; }

        [DataMember]
        public decimal TfLFundsSecured { get; set; }

        [DataMember]
        public decimal RIAFundsSecured { get; set; }

        [DataMember]
        public decimal BISFundsSecured { get; set; }

        [DataMember]
        public string FundingComments { get; set; }

        [DataMember]
        public bool? IsIncifAuthoritytoProceed { get; set; }

        [DataMember]
        public string IncifPurchaseOrderNumber { get; set; }

        [DataMember]
        public decimal IncifMaximumValueofWork { get; set; }

        [DataMember]
        public string IncifDelegatedAuthorityName { get; set; }

        [DataMember]
        public string IncifDelegatedAuthorityTitle { get; set; }

        [DataMember]
        public string IncifDelegatedAuthorityContactNumber { get; set; }

        [DataMember]
        public DateTime IncifDelegatedAuthorityDate { get; set; }

        [DataMember]
        public string ICSCRef { get; set; }

        [DataMember]
        public DateTime DateofICSC { get; set; }

        [DataMember]
        public bool? IsICSCAuthoritytoProceed { get; set; }

        [DataMember]
        public string IARef { get; set; }

        [DataMember]
        public DateTime DateofIA { get; set; }

        [DataMember]
        public bool? IsIAAuthoritytoProceed { get; set; }

        [DataMember]
        public decimal IAMaximumValueofWork { get; set; }

        [DataMember]
        public bool? IsExternalAuthoritytoProceed { get; set; }

        [DataMember]
        public string ExternalRef { get; set; }

        [DataMember]
        public decimal ExternalMaximumValueofWork { get; set; }

        [DataMember]
        public string ExternalDelegatedAuthorityName { get; set; }

        [DataMember]
        public string ExternalDelegatedAuthorityTitle { get; set; }

        [DataMember]
        public string ExternalDelegatedAuthorityContactNumber { get; set; }

        [DataMember]
        public DateTime ExternalDelegatedAuthorityDate { get; set; }

        [DataMember]
        public string ExternalFundingComments { get; set; }
    }
}