﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Runtime.Serialization;
using System.ComponentModel.DataAnnotations.Schema;

namespace Crossrail.IMS.DataGateway
{
    [DataContract]
    public abstract class InnovationRemitBase
    {
        [DataMember]
        public Guid ID { get; set; }
        public int InnovationID { get; set; }
    }
    [DataContract]
    public class InnovationRemitImp : InnovationRemitBase
    {
        [DataMember]
        public string IR_ImpDescription { get; set; }
        [DataMember]
        public DateTime? IR_ImpStart { get; set; }
        [DataMember]
        public DateTime? IR_ImpFinish { get; set; }
        [DataMember]
        public string IR_ImpCost { get; set; }
    }
    [DataContract]
    public class InnovationRemitAuthProceed : InnovationRemitBase
    {
        [DataMember]
        public string IR_HoldPointDescript { get; set; }
        [DataMember]
        public string IR_AuthProceedName { get; set; }
        [DataMember]
        public string IR_AuthProceedDate { get; set; }
    }
    [DataContract]
    public class InnovationRemitResponsible : InnovationRemitBase
    {
        [DataMember]
        public string IR_ResponsibleName { get; set; }
        [DataMember]
        public string IR_ResponsibleRole { get; set; }
        [DataMember]
        public string IR_ResponsibleHours { get; set; }
    }
    [DataContract]
    public class InnovationRemitSuccessFailure : InnovationRemitBase
    {
        [DataMember]
        public string IR_SuccessFailDescript { get; set; }
        [DataMember]
        public string IR_Whenassessed { get; set; }
        [DataMember]
        public string IR_HowMeasured { get; set; }
    }
    [DataContract]
    public class InnovationRemitSuppoter : InnovationRemitBase
    {
        [DataMember]
        public string IR_SupporterName { get; set; }
        [DataMember]
        public string IR_SupporterRole { get; set; }
    }
}