﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Web;
using System.Runtime.Serialization;

namespace Crossrail.IMS.DataGateway
{
    [DataContract]
    public class User
    {
        /// <summary>
        /// UserId
        /// </summary>
        [DataMember]
        public int ID { get; set; }

        /// <summary>
        /// IsDiabled
        /// </summary>
        [DataMember]
        public int RoleID { get; set; }

        /// <summary>
        /// UserName
        /// </summary>
        [DataMember]
        public string UserName { get; set; }

        /// <summary>
        /// FullName
        /// </summary>
        [DataMember]
        public string FullName { get; set; }

        /// <summary>
        /// Email
        /// </summary>
        [DataMember]
        public string Email { get; set; }

        /// <summary>
        /// ContactNumber
        /// </summary>
        [DataMember]
        public string ContactNumber { get; set; }

        /// <summary>
        /// IsDiabled
        /// </summary>
        [DataMember]
        public bool IsDisabled { get; set; }

        /// <summary>
        /// Get the display name of user's role
        /// </summary>
        [DataMember]
        [NotMapped]
        public string RoleName { get; set; }

        /// <summary>
        /// Get all proposing site/project/directorate
        /// </summary>
        [DataMember]
        [NotMapped]
        public List<InnovationData> ProposingItems { get; set; }

        [DataMember]
        public ICollection<UserChampionFor> ChampionFors { get; set; }

        [DataMember]
        [NotMapped]
        public ICollection<string> ChampionForNames { get; set; }
    }

    [DataContract]
    public class UserChampionFor
    {
        [DataMember]
        public int UserID { get; set; }
        [DataMember]
        public int ChampionForID { get; set; }

        [ForeignKey("UserID")]
        public User User { get; set; }
        [ForeignKey("ChampionForID")]
        public InnovationData ChampionFor { get; set; }
    }
}