﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;

namespace Crossrail.IMS.DataGateway.Repositories
{
	public class ActionsRequiredRepositoryTemp : IActionsRequiredRepositoryTemp
	{
        public int AddActionsRequiredTemporary(ActionsRequiredTemporary actionsRequired, string userName)
		{
			try
			{
				using (var _mainContext = new MainContext())
				{
                    actionsRequired.Innovation = null;
                    _mainContext.ActionsRequiredTemps.Add(actionsRequired);
                    _mainContext.SaveChanges(userName);
                    return actionsRequired.ID;

                    //var innovation = _mainContext.Innovations.Find(actionsRequired.Innovation.ID);
                    //if (innovation != null)
                    //{
                    //    actionsRequired.Innovation = innovation;
                    //    _mainContext.ActionsRequiredTemps.Add(actionsRequired);
                    //    _mainContext.SaveChanges(userName);
                    //    return actionsRequired.ID;
                    //}
                    //return 0;
				}
			}
			catch (Exception ex)
			{
				throw ex;
			}
		}

        public int UpdateActionsRequiredTemporary(ActionsRequiredTemporary actionsRequired, string userName)
		{
			try
			{
				using (var _mainContext = new MainContext())
				{
					var ent = _mainContext.ActionsRequiredTemps.Find(actionsRequired.ID);
					if (ent != null)
					{
						var attachedEntry = _mainContext.Entry(ent);
						attachedEntry.CurrentValues.SetValues(actionsRequired);
					}
					else
					{
						_mainContext.Entry(actionsRequired).State = EntityState.Modified;
					}

					return _mainContext.SaveChanges(userName);
				}
			}
			catch (Exception ex)
			{
				throw ex;
			}

		}

        public int DeleteActionsRequiredTemporary(int id, string userName)
		{
			try
			{
				using (var _mainContext = new MainContext())
				{
					var entity = _mainContext.ActionsRequiredTemps.Find(id);
					if (entity != null)
					{
						_mainContext.ActionsRequiredTemps.Remove(entity);
						return _mainContext.SaveChanges(userName);
					}
					return 0;
				}
			}
			catch (Exception ex)
			{
				throw ex;
			}
		}

        public List<ActionsRequiredTemporary> GetAllActionsRequiredTemporaryByInnovationId(int innovationId,Guid temptId)
		{
			try
			{
				using (var _mainContext = new MainContext())
				{
					List<ActionsRequiredTemporary> result = _mainContext.ActionsRequiredTemps
                                                               .Where(p => p.Innovation.ID == innovationId || p.TemptId == temptId).ToList();

					return result;
				}
			}
			catch (Exception ex)
			{
				throw ex;
			}
		}

		public void FillActionsRequiredTemporaryByInnovationId(int innovationId)
		{
			try
			{
				using (var _mainContext = new MainContext())
				{
					List<ActionsRequired> result = _mainContext.ActionsRequireds.Where(p => p.Innovation.ID == innovationId).ToList();
					var innovation = _mainContext.Innovations.Find(innovationId);
					result.ForEach(p =>
					{
						var temp = new ActionsRequiredTemporary()
						{
							Innovation = innovation,
							OrgID = p.ID,
							Actions = p.Actions,
							Completed = p.Completed,
							Owner = p.Owner,
                            TemptId = p.TemptId
						};

						_mainContext.ActionsRequiredTemps.Add(temp);
					});

					_mainContext.SaveChanges();
				}
			}
			catch (Exception ex)
			{
				throw ex;
			}
		}

		public void CleanupActionsRequiredTemporaryByInnovationId(int innovationId)
		{
			try
			{
				using (var _mainContext = new MainContext())
				{
                    var actionRequired = _mainContext.ActionsRequireds.Where(p => p.Innovation.ID == innovationId).FirstOrDefault();
                    if (actionRequired != null)
                    {
                        List<ActionsRequiredTemporary> result = _mainContext.ActionsRequiredTemps.Where(p => p.TemptId == actionRequired.TemptId || p.Innovation.ID == innovationId).ToList();
                        result.ForEach(p =>

                            _mainContext.ActionsRequiredTemps.Remove(p)
                        );

                        _mainContext.SaveChanges();
                    }
				}
			}
			catch (Exception ex)
			{
				throw ex;
			}
		}

		public int SaveActionsRequired(int innovationId, string userName,List<ActionsRequiredTemporary> actionsRequiredTemporaryList)
		{
			try
			{
				using (var _mainContext = new MainContext())
				{
					var innovation = _mainContext.Innovations.Find(innovationId);

					var actionsRequireds = _mainContext.ActionsRequireds.Where(p => p.Innovation.ID == innovationId).ToList();
					actionsRequireds.ForEach(p =>
					{
						var tempEntity = actionsRequiredTemporaryList.Find(e => e.OrgID == p.ID);
						//Delete
						if (ReferenceEquals(tempEntity, null))
						{
							_mainContext.ActionsRequireds.Remove(p);
						}
						//Update
						else
						{
							_mainContext.Innovations.Attach(innovation);
							var ent = _mainContext.ActionsRequireds.Find(p.ID);
							ent.Innovation = innovation;
							ent.Actions = tempEntity.Actions;
							ent.Completed = tempEntity.Completed;
							ent.Owner = tempEntity.Owner;
                            ent.TemptId = tempEntity.TemptId;
							_mainContext.Entry(ent).State = EntityState.Modified;
						}
					});

					actionsRequiredTemporaryList.ForEach(t =>
					{
						var p = actionsRequireds.Find(e => e.ID == t.OrgID);
						if (ReferenceEquals(p, null))
						{
							//Add New
							_mainContext.ActionsRequireds.Add(new ActionsRequired()
							{
								Actions = t.Actions,
								Owner = t.Owner,
								Completed = t.Completed,
                                TemptId = t.TemptId,
								Innovation = innovation
							});
						}
					});
					return _mainContext.SaveChanges(userName);
				}

				return 0;
			}
			catch (Exception ex)
			{
				throw ex;
			}
		}
	}
}