﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Crossrail.IMS.Common;

namespace Crossrail.IMS.DataGateway.Repositories
{
	public interface IInnovationDataRepository
	{
		/// <summary>
		/// Adds the innovation data.
		/// </summary>
		/// <returns></returns>
        int AddInnovationData(InnovationData innovationData, string userName);

        InnovationData GetInnovationDataById(int id);

		/// <summary>
		/// Updates the innovation data.
		/// </summary>
		/// <returns></returns>
        int UpdateInnovationData(InnovationData innovationData, string userName);

		/// <summary>
		/// Deletes the innovation data.
		/// </summary>
		/// <returns></returns>
        int DeleteInnovationData(int innovationDataId, string userName);

		/// <summary>
		/// Gets the innovation data by category.
		/// </summary>
		/// <param name="category">The category.</param>
		/// <returns></returns>
		List<InnovationData> GetInnovationDataByCategory(InnovationDataCategory category);

		/// <summary>
		/// Finds the specified id.
		/// </summary>
		/// <param name="id">The innovation data id.</param>
		/// <returns></returns>
		InnovationData Find(int id);

		/// <summary>
		/// Determines whether [is innovation data value exist] [the specified id].
		/// </summary>
		/// <param name="id">The id.</param>
		/// <param name="dataValue">The data value.</param>
		/// <returns>
		///   <c>true</c> if [is innovation data value exist] [the specified id]; otherwise, <c>false</c>.
		/// </returns>
		bool IsInnovationDataValueExist(int id, string dataValue , InnovationDataCategory category);
	}
}