﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Crossrail.IMS.DataGateway.Repositories
{
    public interface IInnovationFinancialRepository
    {
        /// <summary>
        /// Add a innovation to the system
        /// </summary>
        int AddInnovationFinancial(InnovationFinancial innovationFinancial, string userName);

        /// <summary>
        /// Get innovation financial by innovationFinancialID
        /// </summary>
        InnovationFinancial GetInnovationFinancialById(int innovationFinancialId);

        /// <summary>
        /// Get innovation financial by innovationId
        /// </summary>
        /// <param name="innovationId"></param>
        /// <returns></returns>
        InnovationFinancial GetInnovationFinancialByInnovationId(int innovationId);

        /// <summary>
        /// Update innovation
        /// </summary>
        int UpdateInnovationFinancial(InnovationFinancial innovationFinancial, string userName);

        /// <summary>
        /// Delete innovation
        /// </summary>
        /// <param name="userName"></param>
        /// <returns></returns>
        bool DeleteInnovationFinancial(int innovationFinancialId, string userName);

        /// <summary>
        /// Get innovation financial by innovationFinancialID
        /// </summary>
        InnovationFinancial GetInnovationFinancialByInRef(string inRef);
    }
}
