﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace Crossrail.IMS.DataGateway.Repositories
{
	public interface IInnovationProgressRepository
	{
		/// <summary>
		/// Creates the innocation progress.
		/// </summary>
		/// <param name="innovationProgress">The innovation progress.</param>
		/// <returns></returns>
        int CreateInnovationProgress(InnovationProgress innovationProgress, string userName);

		/// <summary>
		/// Updates the innovation progress.
		/// </summary>
		/// <param name="innovationProgress">The innovation progress.</param>
		/// <returns></returns>
        int UpdateInnovationProgress(InnovationProgress innovationProgress, string userName);

		/// <summary>
		/// Gets the innocation progress.
		/// </summary>
		/// <param name="innovationId">The innovation id.</param>
		/// <returns></returns>
		InnovationProgress GetInnovationProgress(int innovationId);

        /// <summary>
        /// Gets the innocation progress.
        /// </summary>
        /// <param name="innovationId">The innovation id.</param>
        /// <returns></returns>
        InnovationProgress GetInnovationProgressByInRef(string inRef);

	}
}