﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Crossrail.IMS.DataGateway.Repositories
{
    public interface IInnovationRepository
    {
        /// <summary>
        /// Add a innovation to the system
        /// </summary>
        int AddInnovation(Innovation innovation, string userName);

        /// <summary>
        /// Get innovation by innovationID
        /// </summary>
        Innovation GetInnovationById(int innovationId);
        

        /// <summary>
        /// Update innovation
        /// </summary>
        int UpdateInnovation(Innovation innovation, string userName);

        /// <summary>
        /// Delete innovation
        /// </summary>
        /// <param name="userName"></param>
        /// <returns></returns>
        bool DeleteInnovation(int innovationId, string userName);

        /// <summary>
        /// Get all innovations filtered by user's role/
        /// </summary>
        /// <param name="userName"></param>
        /// <returns></returns>
        List<Innovation> GetAllInnovations(string userName, int pageNumber, int pageSize, string sortColumn, string sortDir, out int total);

        int CancelinnovationDetail(int innovationId, string innovationRef, string userName);

        List<InnovationRemitImp> GetInnovationRemitImps(int innovationId);

        List<InnovationRemitResponsible> GetInnovationRemitResponsibles(int innovationId);

        List<InnovationRemitSuccessFailure> GetInnovationRemitSuccessFailures(int innovationId);

        List<InnovationRemitAuthProceed> GetInnovationRemitAuthProceeds(int innovationId);

        List<InnovationRemitSuppoter> GetInnovationRemitSuppoters(int innovationId);
    }
}
