﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Runtime.Serialization;

namespace Crossrail.IMS.DataGateway.Repositories
{
	public interface ISubThemeRepository
	{
		/// <summary>
		/// Adds the sub theme.
		/// </summary>
		/// <param name="subTheme">The sub theme.</param>
		/// <returns></returns>
        int AddSubTheme(SubTheme subTheme, string userName);

		/// <summary>
		/// Updates the innovation data.
		/// </summary>
		/// <returns></returns>
        int UpdateSubTheme(SubTheme subTheme, string userName);

		/// <summary>
		/// Deletes the innovation data.
		/// </summary>
		/// <returns></returns>
        int DeleteSubTheme(int subThemeId, string userName);

		/// <summary>
		/// Gets the innovation data by category.
		/// </summary>
		/// <returns></returns>
		List<SubTheme> GetSubThemes();

		/// <summary>
		/// Finds the sub theme.
		/// </summary>
		/// <param name="subThemeId">The sub theme id.</param>
		/// <returns></returns>
		SubTheme FindSubTheme(int subThemeId);


		/// <summary>
		/// Determines whether [is sub theme name exist] [the specified id].
		/// </summary>
		/// <param name="id">The id.</param>
		/// <param name="dataValue">The data value.</param>
		/// <returns>
		///   <c>true</c> if [is sub theme name exist] [the specified id]; otherwise, <c>false</c>.
		/// </returns>
		bool IsSubThemeNameExist(int id, string dataValue);

        /// <summary>
        /// Get sub themes by themeId
        /// </summary>
        /// <param name="themeID"></param>
        /// <returns></returns>
	    List<SubTheme> GetSubThemeByThemeID(int themeID);
	}
}