﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace Crossrail.IMS.DataGateway.Repositories
{
    public class InnovationFinancialRepository : IInnovationFinancialRepository
    {
        /// <summary>
        /// The _main context
        /// </summary>
        private MainContext _mainContext = new MainContext();

        public int AddInnovationFinancial(InnovationFinancial innovationFinancial, string userName)
        {
            int innovationFinancialId = 0;
            try
            {
                using (var context = new MainContext())
                {
                    var innovation = context.Innovations.FirstOrDefault(i => i.ID == innovationFinancial.Innovation.ID);
                    if (innovation != null)
                    {
						context.Innovations.Attach(innovation);
                        innovationFinancial.Innovation = innovation;

                        context.InnovationFinancials.Add(innovationFinancial);
                        innovationFinancialId = context.SaveChanges(userName);
                    }

                    return innovationFinancialId;
                }

            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        public InnovationFinancial GetInnovationFinancialById(int innovationFinancialId)
        {
            InnovationFinancial result = null;
            try
            {
                using (var context = new MainContext())
                {
                    result = context.InnovationFinancials.FirstOrDefault(i => i.ID == innovationFinancialId);
                }
                return result;

            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        public InnovationFinancial GetInnovationFinancialByInnovationId(int innovationId)
        {
            InnovationFinancial result = null;
            try
            {
                using (var context = new MainContext())
                {
					result = context.InnovationFinancials.FirstOrDefault(i => i.Innovation.ID == innovationId);
                }
                return result;

            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        public int UpdateInnovationFinancial(InnovationFinancial innovationFinancial, string userName)
        {            
            try
            {
                if (innovationFinancial.ID == 0)
                {
                    return AddInnovationFinancial(innovationFinancial, userName);
                }

                using (var context = new MainContext())
                {
					var ent = context.InnovationFinancials.Find(innovationFinancial.ID);
					if (ent != null)
					{
						var innovation = context.Innovations.Find(innovationFinancial.Innovation.ID);
						context.Innovations.Attach(innovation);
						ent.Innovation = innovation;
						
						var attachedEntry = context.Entry(ent);
						attachedEntry.CurrentValues.SetValues(innovationFinancial);
					}

                    return context.SaveChanges(userName);

					//var systemInnovation = context.InnovationFinancials.FirstOrDefault(i => i.ID == innovationFinancial.ID);
					//if (systemInnovation != null)
					//{

					//    systemInnovation.InnovationRef = innovationFinancial.InnovationRef;
					//    //systemInnovation.ExpenditureToDate = innovationFinancial.;
					//    systemInnovation.TotalAuthorisedInvestment = innovationFinancial.TotalAuthorisedInvestment;
					//    systemInnovation.CRLAuthorisedInvestment = innovationFinancial.CRLAuthorisedInvestment;
					//    systemInnovation.TSLGFundsSecured = innovationFinancial.TSLGFundsSecured;
					//    systemInnovation.TfLFundsSecured = innovationFinancial.TfLFundsSecured;
					//    systemInnovation.RIAFundsSecured = innovationFinancial.RIAFundsSecured;
					//    systemInnovation.BISFundsSecured = innovationFinancial.BISFundsSecured;
					//    systemInnovation.FundingComments = innovationFinancial.FundingComments;
					//    systemInnovation.IsIncifAuthoritytoProceed = innovationFinancial.IsIncifAuthoritytoProceed;
					//    systemInnovation.IncifPurchaseOrderNumber = innovationFinancial.IncifPurchaseOrderNumber;
					//    systemInnovation.IncifMaximumValueofWork = innovationFinancial.IncifMaximumValueofWork;
					//    systemInnovation.IncifDelegatedAuthorityName = innovationFinancial.IncifDelegatedAuthorityName;
					//    systemInnovation.IncifDelegatedAuthorityTitle = innovationFinancial.IncifDelegatedAuthorityTitle;
					//    systemInnovation.IncifDelegatedAuthorityContactNumber = innovationFinancial.IncifDelegatedAuthorityContactNumber;
					//    systemInnovation.IncifDelegatedAuthorityDate = innovationFinancial.IncifDelegatedAuthorityDate;
					//    systemInnovation.ICSCRef = innovationFinancial.ICSCRef;
					//    systemInnovation.DateofICSC = innovationFinancial.DateofICSC;
					//    systemInnovation.IsICSCAuthoritytoProceed = innovationFinancial.IsICSCAuthoritytoProceed;
					//    systemInnovation.IARef = innovationFinancial.IARef;
					//    systemInnovation.DateofIA = innovationFinancial.DateofIA;
					//    systemInnovation.IsIAAuthoritytoProceed = innovationFinancial.IsIAAuthoritytoProceed;
					//    systemInnovation.IAMaximumValueofWork = innovationFinancial.IAMaximumValueofWork;
					//    systemInnovation.IsExternalAuthoritytoProceed = innovationFinancial.IsExternalAuthoritytoProceed;
					//    systemInnovation.ExternalRef = innovationFinancial.ExternalRef;
					//    systemInnovation.ExternalMaximumValueofWork = innovationFinancial.ExternalMaximumValueofWork;
					//    systemInnovation.ExternalDelegatedAuthorityName = innovationFinancial.ExternalDelegatedAuthorityName;
					//    systemInnovation.ExternalDelegatedAuthorityTitle = innovationFinancial.ExternalDelegatedAuthorityTitle;
					//    systemInnovation.ExternalDelegatedAuthorityContactNumber = innovationFinancial.ExternalDelegatedAuthorityContactNumber;
					//    systemInnovation.ExternalDelegatedAuthorityDate = innovationFinancial.ExternalDelegatedAuthorityDate;
					//    systemInnovation.ExternalFundingComments = innovationFinancial.ExternalFundingComments;
					//}
					//context.Entry(systemInnovation).State = EntityState.Modified;
					//return context.SaveChanges();
                }

            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        public bool DeleteInnovationFinancial(int innovationFinancialId, string userName)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Get innovation financial by innovationFinancialID
        /// </summary>
        public InnovationFinancial GetInnovationFinancialByInRef(string inRef)
        {
            InnovationFinancial result = null;
            try
            {
                var innovation = _mainContext.Innovations.Where(x => x.InnovationRef == inRef).FirstOrDefault();
                if (innovation != null)
                {
                    result =
                        _mainContext.InnovationFinancials.Where(x => x.InnovationRef == innovation.InnovationRef || x.Innovation.ID == innovation.ID).
                            FirstOrDefault();
                }
                return result;

            }
            catch (Exception ex)
            {
                throw ex;
            }
        }
    }
}