﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;

namespace Crossrail.IMS.DataGateway.Repositories
{
	public class LinkedDocumentRepository : ILinkedDocumentRepository
	{
		public int AddLinkedDocument(LinkedDocument linkedDocument, string userName)
		{
			try
			{
				using (var _mainContext = new MainContext())
				{
					var innovation = _mainContext.Innovations.Find(linkedDocument.Innovation.ID);
					if (innovation != null)
					{
						linkedDocument.Innovation = innovation;
						_mainContext.LinkedDocuments.Add(linkedDocument);
						_mainContext.SaveChanges(userName);
						return linkedDocument.ID;
					}
					return 0;
				}
			}
			catch (Exception ex)
			{
				throw ex;
			}
		}

		public int UpdateLinkedDocument(LinkedDocument linkedDocument, string userName)
		{
			try
			{
				using (var _mainContext = new MainContext())
				{
					var ent = _mainContext.LinkedDocuments.Find(linkedDocument.ID);
					if (ent != null)
					{
						var attachedEntry = _mainContext.Entry(ent);
						attachedEntry.CurrentValues.SetValues(linkedDocument);
					}
					else
					{
						_mainContext.Entry(linkedDocument).State = EntityState.Modified;
					}

					return _mainContext.SaveChanges(userName);
				}
			}
			catch (Exception ex)
			{
				throw ex;
			}
		}

		public int DeleteLinkedDocument(int id, string userName)
		{
			try
			{
				using (var _mainContext = new MainContext())
				{
					var entity = _mainContext.LinkedDocuments.Find(id);
					if (entity != null)
					{
						_mainContext.LinkedDocuments.Remove(entity);
						return _mainContext.SaveChanges(userName);
					}
					return 0;
				}
			}
			catch (Exception ex)
			{
				throw ex;
			}
		}

		public List<LinkedDocument> GetLinkedDocumentsByInnovationId(int innovationId)
		{
			try
			{
				using (var _mainContext = new MainContext())
				{
					List<LinkedDocument> result = _mainContext.LinkedDocuments
															   .Where(p => p.Innovation.ID == innovationId).ToList();

					return result;
				}
			}
			catch (Exception ex)
			{
				throw ex;
			}
		}

		public LinkedDocument GetLinkedDocumentById(int id)
		{
			try
			{
				using (var _mainContext = new MainContext())
				{
					var result = _mainContext.LinkedDocuments.Find(id);
					return result;
				}
			}
			catch (Exception ex)
			{
				throw ex;
			}
		}

		public void ResetDocumentStatus(int innovationId, string userName)
		{
			try
			{
				using (var _mainContext = new MainContext())
				{
					List<LinkedDocument> result = _mainContext.LinkedDocuments
															   .Where(p => p.Innovation.ID == innovationId).ToList();
					result.ForEach(doc =>
						{
							if (doc.IsDeleted.HasValue && doc.IsDeleted.Value)
							{
								doc.IsDeleted = null;
								UpdateLinkedDocument(doc, userName);
							}
							else if (doc.IsNew.HasValue && doc.IsNew.Value)
							{
								DeleteLinkedDocument(doc.ID, userName);
							}

						});
				}
			}
			catch (Exception ex)
			{
				throw ex;
			}
		}
	}
}