﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;

namespace Crossrail.IMS.DataGateway.Repositories
{
    public class PeopleSupportRepository : IPeopleSupportRepository
    {

        /// <summary>
        /// The _main context
        /// </summary>
        //private MainContext _mainContext;

        public PeopleSupportRepository()
        {
            //_mainContext = new MainContext();
            //_mainContext.Configuration.LazyLoadingEnabled = false;
        }

        public int AddPeopleSupport(PeopleSupport peopleSupport, string userName)
        {
            try
            {
                using (var _mainContext = new MainContext())
                {
                    var innovation = _mainContext.Innovations.Find(peopleSupport.Innovation.ID);
                    if (innovation != null)
                    {
                        peopleSupport.Innovation = innovation;
                        _mainContext.PeopleSupports.Add(peopleSupport);
                        _mainContext.SaveChanges(userName);
                        return peopleSupport.ID;
                    }
                    return 0;
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        public int UpdatePeopleSupport(PeopleSupport peopleSupport, string userName)
        {
            try
            {
                using (var _mainContext = new MainContext())
                {
                    var ent = _mainContext.PeopleSupports.Find(peopleSupport.ID);
                    if (ent != null)
                    {
                        var attachedEntry = _mainContext.Entry(ent);
                        attachedEntry.CurrentValues.SetValues(peopleSupport);
                    }
                    else
                    {
                        _mainContext.Entry(peopleSupport).State = EntityState.Modified;
                    }
                    return _mainContext.SaveChanges(userName);
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        public int DeletePeopleSupport(int id, string userName)
        {
            try
            {
                using (var _mainContext = new MainContext())
                {
                    var entity = _mainContext.PeopleSupports.Find(id);
                    if (entity != null)
                    {
                        _mainContext.PeopleSupports.Remove(entity);
                        return _mainContext.SaveChanges(userName);
                    }
                }

                return 0;
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        public List<PeopleSupport> GetAllPeopleSupportByInnovationId(int innovationId)
        {
            try
            {
                using (var _mainContext = new MainContext())
                {
                    List<PeopleSupport> result = _mainContext.PeopleSupports.Where(p => p.Innovation.ID == innovationId).ToList();
                    return result;
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }        
    }
}