﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;

namespace Crossrail.IMS.DataGateway.Repositories
{
    public class PeopleSupportTempRepository : IPeopleSupportTempRepository
    {
        public int AddPeopleSupportTemporary(PeopleSupportTemporary peopleSupport, string userName)
        {
            try
            {
                using (var _mainContext = new MainContext())
                {
                    peopleSupport.Innovation = null;
                    _mainContext.PeopleSupportTemps.Add(peopleSupport);
                    _mainContext.SaveChanges(userName);
                    return peopleSupport.ID;

                    //var innovation = _mainContext.Innovations.Find(peopleSupport.Innovation.ID);
                    //if (innovation != null)
                    //{
                    //    peopleSupport.Innovation = innovation;
                    //    _mainContext.PeopleSupportTemps.Add(peopleSupport);
                    //    _mainContext.SaveChanges(userName);
                    //    return peopleSupport.ID;
                    //}
                    //return 0;
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        public int UpdatePeopleSupportTemporary(PeopleSupportTemporary peopleSupport, string userName)
        {
            try
            {
                using (var _mainContext = new MainContext())
                {
                    var ent = _mainContext.PeopleSupportTemps.Find(peopleSupport.ID);
                    if (ent != null)
                    {
                        var attachedEntry = _mainContext.Entry(ent);
                        attachedEntry.CurrentValues.SetValues(peopleSupport);
                    }
                    else
                    {
                        _mainContext.Entry(peopleSupport).State = EntityState.Modified;
                    }
                    return _mainContext.SaveChanges(userName);
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        public int DeletePeopleSupportTemporary(int id, string userName)
        {
            try
            {
                using (var _mainContext = new MainContext())
                {
                    var entity = _mainContext.PeopleSupportTemps.Find(id);
                    if (entity != null)
                    {
                        _mainContext.PeopleSupportTemps.Remove(entity);
                        return _mainContext.SaveChanges(userName);
                    }
                }

                return 0;
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        public List<PeopleSupportTemporary> GetAllPeopleSupportTemporaryByInnovationId(int innovationId, Guid temptId)
        {
            try
            {
                using (var _mainContext = new MainContext())
                {
                    List<PeopleSupportTemporary> result = _mainContext.PeopleSupportTemps.Where(p => p.Innovation.ID == innovationId || p.TemptId == temptId).ToList();
                    return result;
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }        

        public void FillPeopleSupportTemporaryByInnovationId(int innovationId)
        {
            try
            {
                using (var _mainContext = new MainContext())
                {
                    List<PeopleSupport> result = _mainContext.PeopleSupports.Where(p => p.Innovation.ID == innovationId).ToList();
                    var innovation = _mainContext.Innovations.Find(innovationId);
                    result.ForEach(p =>
                        {
                            var temp = new PeopleSupportTemporary
                                {
                                    Innovation = innovation,
                                    Name = p.Name,
                                    Reason = p.Reason,
                                    OrgID = p.ID,
                                    TemptId = p.TemptId
                                };

                            _mainContext.PeopleSupportTemps.Add(temp);
                        });

                    _mainContext.SaveChanges();
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        public void CleanupPeopleSupportTemporaryByInnovationId(int innovationId)
        {
            try
            {
                using (var _mainContext = new MainContext())
                {
                    var peopleSupport = _mainContext.PeopleSupports.Where(p => p.Innovation.ID == innovationId).FirstOrDefault();
                    if (peopleSupport != null)
                    {
                        List<PeopleSupportTemporary> result = _mainContext.PeopleSupportTemps.Where(p => p.TemptId == peopleSupport.TemptId || p.Innovation.ID == innovationId).ToList();
                        result.ForEach(p =>

                            _mainContext.PeopleSupportTemps.Remove(p)
                        );
                        _mainContext.SaveChanges();
                    }
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        public int SavePeopleSupport(int innovationId, string userName, List<PeopleSupportTemporary> peopleSupportTemporaryList)
        {
            try
            {
                using (var _mainContext = new MainContext())
                {
                    var innovation = _mainContext.Innovations.Find(innovationId);

                    var peopleSupportList = _mainContext.PeopleSupports.Where(p => p.Innovation.ID == innovationId).ToList();
                    peopleSupportList.ForEach(p =>
                    {
                        var tempEntity = peopleSupportTemporaryList.Find(e => e.OrgID == p.ID);
                        //Delete
                        if (ReferenceEquals(tempEntity, null))
                        {
                            _mainContext.PeopleSupports.Remove(p);
                        }
                        //Update
                        else
                        {
                            _mainContext.Innovations.Attach(innovation);
                            var ent = _mainContext.PeopleSupports.Find(p.ID);
                            ent.Innovation = innovation;
                            ent.Name = tempEntity.Name;
                            ent.Reason = tempEntity.Reason;
                            ent.TemptId = tempEntity.TemptId;
                            _mainContext.Entry(ent).State = EntityState.Modified;
                        }
                    });

                    peopleSupportTemporaryList.ForEach(t =>
                    {
                        var p = peopleSupportList.Find(e => e.ID == t.OrgID);
                        if (ReferenceEquals(p, null))
                        {
                            //Add New
                            _mainContext.PeopleSupports.Add(new PeopleSupport
                            {
                                Name = t.Name,
                                Reason = t.Reason,
                                TemptId = t.TemptId,
                                Innovation = innovation
                            });
                        }
                    });
                    return _mainContext.SaveChanges(userName);
                }

                return 0;
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }
    }
}