﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;

namespace Crossrail.IMS.DataGateway.Repositories
{
	public class ResourcesRequiredTempRepository : IResourcesRequiredTempRepository
	{
        public int AddResourcesRequiredTemporary(ResourcesRequiredTemporary resourcesRequired, string userName)
		{
			try
			{
				using (var _mainContext = new MainContext())
				{
                    resourcesRequired.Innovation = null;
                    _mainContext.ResourcesRequiredTemps.Add(resourcesRequired);
                    _mainContext.SaveChanges(userName);
                    return resourcesRequired.ID;

                    //var innovation = _mainContext.Innovations.Find(resourcesRequired.Innovation.ID);
                    //if (innovation != null)
                    //{
                    //    resourcesRequired.Innovation = innovation;
                    //    _mainContext.ResourcesRequiredTemps.Add(resourcesRequired);
                    //    _mainContext.SaveChanges(userName);
                    //    return resourcesRequired.ID;
                    //}
				}
				return 0;
			}
			catch (Exception ex)
			{
				throw ex;
			}
		}

        public int UpdateResourcesRequiredTemporary(ResourcesRequiredTemporary resourcesRequired, string userName)
		{
			try
			{
				using (var _mainContext = new MainContext())
				{
					var ent = _mainContext.ResourcesRequiredTemps.Find(resourcesRequired.ID);
					if (ent != null)
					{
						var attachedEntry = _mainContext.Entry(ent);
						attachedEntry.CurrentValues.SetValues(resourcesRequired);
					}
					else
					{
						_mainContext.Entry(resourcesRequired).State = EntityState.Modified;
					}

					return _mainContext.SaveChanges(userName);
				}
			}
			catch (Exception ex)
			{
				throw ex;
			}

		}

        public int DeleteResourcesRequiredTemporary(int id, string userName)
		{
			try
			{
				using (var _mainContext = new MainContext())
				{
					var entity = _mainContext.ResourcesRequiredTemps.Find(id);
					if (entity != null)
					{
						_mainContext.ResourcesRequiredTemps.Remove(entity);
						return _mainContext.SaveChanges(userName);
					}
					return 0;
				}
			}
			catch (Exception ex)
			{
				throw ex;
			}
		}

        public List<ResourcesRequiredTemporary> GetAllResourcesRequiredTemporaryByInnovationId(int innovationId , Guid temptId)
		{
			try
			{
				using (var _mainContext = new MainContext())
				{
					List<ResourcesRequiredTemporary> result = _mainContext.ResourcesRequiredTemps
                                                                 .Where(p => p.Innovation.ID == innovationId || p.TemptId == temptId).ToList();
					return result;
				}
			}
			catch (Exception ex)
			{
				throw ex;
			}
		}

		public void FillResourceRequiredTemporaryByInnovationId(int innovationId)
		{
			try
			{
				using (var _mainContext = new MainContext())
				{
					List<ResourcesRequired> result = _mainContext.ResourcesRequireds.Where(p => p.Innovation.ID == innovationId).ToList();
					var innovation = _mainContext.Innovations.Find(innovationId);
					result.ForEach(p =>
					{
						var temp = new ResourcesRequiredTemporary()
						{
							Innovation = innovation,
							OrgID = p.ID,
							Name = p.Name,
							Hours = p.Hours,
							Output = p.Output,
							Role = p.Role,
                            TemptId = p.TemptId
						};

						_mainContext.ResourcesRequiredTemps.Add(temp);
					});

					_mainContext.SaveChanges();
				}
			}
			catch (Exception ex)
			{
				throw ex;
			}
		}

		public void CleanupResourceRequiredTemporaryByInnovationId(int innovationId)
		{

			try
			{
				using (var _mainContext = new MainContext())
				{
                    var resourceRequired = _mainContext.ResourcesRequireds.Where(p => p.Innovation.ID == innovationId).FirstOrDefault();
                    if (resourceRequired != null)
                    {
                        var result = _mainContext.ResourcesRequiredTemps.Where(p => p.TemptId == resourceRequired.TemptId || p.Innovation.ID == innovationId).ToList();
                        result.ForEach(p =>

                            _mainContext.ResourcesRequiredTemps.Remove(p)
                        );

                        _mainContext.SaveChanges();
                    }
				}
			}
			catch (Exception ex)
			{
				throw ex;
			}
		}

		public int SaveResourcesRequired(int innovationId, string userName,List<ResourcesRequiredTemporary> resourcesRequiredTemporaryList)
		{
			try
			{
				using (var _mainContext = new MainContext())
				{
					var innovation = _mainContext.Innovations.Find(innovationId);

					var resourcesRequireds = _mainContext.ResourcesRequireds.Where(p => p.Innovation.ID == innovationId).ToList();
					resourcesRequireds.ForEach(p =>
					{
						var tempEntity = resourcesRequiredTemporaryList.Find(e => e.OrgID == p.ID);
						//Delete
						if (ReferenceEquals(tempEntity, null))
						{
							_mainContext.ResourcesRequireds.Remove(p);
						}
						//Update
						else
						{
							_mainContext.Innovations.Attach(innovation);
							var ent = _mainContext.ResourcesRequireds.Find(p.ID);
							ent.Innovation = innovation;
							ent.Name = tempEntity.Name;
							ent.Output = tempEntity.Output;
							ent.Role = tempEntity.Role;
							ent.Hours = tempEntity.Hours;
                            ent.TemptId = tempEntity.TemptId;
							_mainContext.Entry(ent).State = EntityState.Modified;
						}
					});

					resourcesRequiredTemporaryList.ForEach(t =>
					{
						var p = resourcesRequireds.Find(e => e.ID == t.OrgID);
						if (ReferenceEquals(p, null))
						{
							//Add New
							_mainContext.ResourcesRequireds.Add(new ResourcesRequired()
							{
								Name = t.Name,
								Output = t.Output,
								Role = t.Role,
								Hours = t.Hours,
                                TemptId = t.TemptId,
								Innovation = innovation
							});
						}
					});
					return _mainContext.SaveChanges(userName);
				}

				return 0;
			}
			catch (Exception ex)
			{
				throw ex;
			}
		}
	}
}