﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Transactions;

namespace Crossrail.IMS.DataGateway.Utilities
{
    public class CommonUtil
    {
        /// <summary>
        /// Get Next Innovation Ref
        /// </summary>
        /// <returns>value of next innovation Ref</returns>
        public static string GetNextInnovationRef()
        {
            try
            {
	            string strInnovationRef = string.Empty;

				using (TransactionScope scope = new TransactionScope(TransactionScopeOption.Required,
					new TransactionOptions { IsolationLevel = System.Transactions.IsolationLevel.RepeatableRead }))
				{
					var context = new MainContext();

					var entity = context.InnvationCurrentRefNumbers.FirstOrDefault();
					var curRefNumber = entity.CurrentRefNumber;

					strInnovationRef = "INV" + (++curRefNumber).ToString("D5");
					entity.CurrentRefNumber = curRefNumber;
					context.Entry(entity).State = EntityState.Modified;

					context.SaveChanges();
					scope.Complete();
				}

				//MainContext _mainContext = new MainContext(); //main context used to access database.
				//string strInnovationRef = string.Empty; //value of innovation Ref will be imported.
				//int intNextInnovationId = 50; //contain next innovation ID
				//if (_mainContext.Innovations.Count() > 0)
				//{
				//    Innovation _lastInnovation = _mainContext.Innovations.ToList().ElementAt(_mainContext.Innovations.Count() - 1);
				//    if (_lastInnovation.InnovationRef.Length == 8)
				//    {
				//        int.TryParse(_lastInnovation.InnovationRef.Substring(3, 5), out intNextInnovationId);
				//        intNextInnovationId += 1;
				//    }
				//}
                
                return strInnovationRef;
            }
            catch(Exception ex)
            {
                return string.Empty;
            }
        }
    }
}