﻿using System.Configuration;

namespace Crossrail.IMS.EmailProcessor
{
  public class AppSettings
  {
    public int JobRunInterval
    {
      get
      {
        return this.GetInt("JobRunInterval", 300000);
      }
    }

    public string EmailTitle
    {
        get
        {
            return this.GetString("EmailTitle", "Innovation Form Submission");
        }
    }

    public string InnovationSubmissionsRootFolder
    {
        get
        {
            return this.GetString("InnovationSubmissionsRootFolder", "\\\\fdc2pmssql003\\imsdataimport\\InnovationSubmissions\\");
        }
    }

    public string InnovationSubmissionsTempImportFolder
    {
        get
        {
            return this.GetString("InnovationSubmissionsTempImportFolder", "\\\\fdc2pmssql003\\imsdataimport\\InnovationSubmissions\\TempImport\\");
        }
    }

    public string FileNameFormat
    {
        get
        {
            return this.GetString("FileNameFormat", "yyyyMMddHHmmssfff");
        }
    }

    public string FileExtension
    {
        get
        {
            return this.GetString("FileExtension", "xml");
        }
    }

    public string InnovationsMailBoxSmtpAddress
    {
        get
        {
            return this.GetString("InnovationsMailBoxSmtpAddress", "willvogli@crossrail.co.uk");
        }
    }

    public string DelegatedUser_UserName
    {
        get
        {
            return this.GetString("DelegatedUser_UserName", "Aybars Sogancilar");
        }
    }

    public string DelegatedUser_Password
    {
        get
        {
            return this.GetString("DelegatedUser_Password", "Srabyailsa77");
        }
    }

    public string DelegatedUser_DomainName
    {
        get
        {
            return this.GetString("DelegatedUser_DomainName", "CRLAD");
        }
    }

    public string ArchiveEmailFolderDisplayName
    {
        get
        {
            return this.GetString("ArchiveEmailFolderDisplayName", "Archive");
        }
    }

    public string EWSWebServiceUrl
    {
        get
        {
            return this.GetString("EWSWebServiceUrl", "https://mail2.crlad.crossrail.co.uk/EWS/Exchange.asmx");
        }
    }

    public int EmailSearchResultSize
    {
        get
        {
            return this.GetInt("EmailSearchResultSize", 50);
        }
    }

    public string WindowsServiceEmailSubject
    {
        get
        {
            return this.GetString("WindowsServiceEmailSubject", "Crossrail.IMS.EmailProcessor");
        }
    }

    public string WindowsServiceEmailRecipientList
    {
        get
        {
            return this.GetString("WindowsServiceEmailRecipientList", "sbasupport@crossrail.co.uk");
        }
    }

    public string WindowsServiceEmailFromValue
    {
        get
        {
            return this.GetString("WindowsServiceEmailFromValue", "SA_Appsagent@crossrail.co.uk");
        }
    }

    public string WindowsServiceEmailSmtpHost
    {
        get
        {
            return this.GetString("WindowsServiceEmailSmtpHost", "smtp-apps.crlad.crossrail.co.uk");
        }
    }

    public int NotificationIntervalInMinutes
    {
      get
      {
        return this.GetInt("NotificationIntervalInMinutes", 60);
      }
    }

    private string GetString(string key, string @default)
    {
      return ConfigurationManager.AppSettings[key] ?? @default;
    }

    private int GetInt(string key, int @default)
    {
      int result;
      if (!int.TryParse(this.GetString(key, @default.ToString()), out result))
        result = @default;
      return result;
    }
  }
}
