﻿using System.Net;
using System.Net.Mail;

namespace Crossrail.IMS.EmailProcessor {
    internal class EmailSender {
        public void SendEmail(string body) {
            try {
                var appSettings = new AppSettings();
                var smtpClient = new SmtpClient(appSettings.WindowsServiceEmailSmtpHost)
                    {
                        Credentials = CredentialCache.DefaultNetworkCredentials,
                        DeliveryMethod = SmtpDeliveryMethod.Network
                    };
                var message = new MailMessage
                    {
                        From = new MailAddress(appSettings.WindowsServiceEmailFromValue),
                        Body = body,
                        Subject = appSettings.WindowsServiceEmailSubject
                    };
                message.To.Add(appSettings.WindowsServiceEmailRecipientList);
                smtpClient.Send(message);
            }
            catch {}
        }
    }
}