﻿
using System;
using System.Text;
using log4net;

namespace Crossrail.IMS.EmailProcessor {
    public static class LoggerExtensions {
        public static void LogInfo(this ILog log, string message, bool sendEmail = false) {
            log.Info(message);
            if (!sendEmail)
                return;
            new EmailSender().SendEmail(message);
        }

        public static void LogError(this ILog log, string message, Exception ex, bool sendEmail = false) {
            log.Error(message, ex);
            if (!sendEmail)
                return;
            var stringBuilder = new StringBuilder();
            stringBuilder.AppendLine(message);
            if (ex != null)
                stringBuilder.AppendLine((ex).ToString());
            new EmailSender().SendEmail((stringBuilder).ToString());
        }

        public static void LogError(this ILog log, string message, bool sendEmail = false) {
            log.Error(message);
            if (!sendEmail)
                return;
            var stringBuilder = new StringBuilder();
            stringBuilder.AppendLine(message);
            new EmailSender().SendEmail((stringBuilder).ToString());
        }
    }
}