﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Linq;
using System.ServiceProcess;
using System.Text;
using System.ServiceModel;
using System.Configuration;

namespace Crossrail.IMS.ImportInnovation.Hosting
{
    public partial class ImportInnovationService : ServiceBase
    {
        // the service host type
        internal static ServiceHost myServiceHost = null; 

        /// <summary>
        /// Constructure of this class
        /// </summary>
        public ImportInnovationService()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Start the service
        /// </summary>
        /// <param name="args"></param>
        protected override void OnStart(string[] args)
        {
            System.Timers.Timer timer = new System.Timers.Timer();
            timer.Interval = Double.Parse(ConfigurationManager.AppSettings["ImportInnovationInterval"]);
            timer.AutoReset = true;
            timer.Enabled = true;
            timer.Start();
            timer.Elapsed += new System.Timers.ElapsedEventHandler(ImportInnovationTimerElapsed);
        }

        /// <summary>
        /// Stop the service
        /// </summary>
        protected override void OnStop()
        {
            // Do nothing
        }

        /// <summary>
        /// Execute Importing Innovation
        /// </summary>
        /// <param name="sender">The timer</param>
        /// <param name="e">The event argument</param>
        private void ImportInnovationTimerElapsed(object sender, EventArgs e)
        {
            Crossrail.IMS.ImportInnovation.ImportInnovationService importInnovation;
            using (importInnovation = new ImportInnovation.ImportInnovationService())
            {
                importInnovation.DoImportInnovation();
            };
        }
    }
}
