﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Crossrail.IMS.WebApp.DataGatewayService;
using System.ComponentModel.DataAnnotations;
using Crossrail.IMS.Common;
using Crossrail.IMS.WebApp.Utilities;

namespace Crossrail.IMS.WebApp.Models
{
    public class InnovationFinancialsModel
    {
        public InnovationFinancialsModel()
        {
            IsIncifAuthoritytoProceed = IsICSCAuthoritytoProceed = IsExternalAuthoritytoProceed = true;
        }

        #region Properties
        public int ID { get; set; }

        public Innovation Innovation { get; set; }

        public string InnovationRef { get; set; }

        [CustomAttribute.Decimal(ErrorMessage = Common.Constant.InnovationDetailErrorCode.ErrorMessageNumber)]
        public decimal ExpenditureToDate { get; set; }

        [CustomAttribute.Decimal(ErrorMessage = Common.Constant.InnovationDetailErrorCode.ErrorMessageNumber)]
        public decimal TotalAuthorisedInvestment { get; set; }

        [CustomAttribute.Decimal(ErrorMessage = Common.Constant.InnovationDetailErrorCode.ErrorMessageNumber)]
        public decimal CRLAuthorisedInvestment { get; set; }

        [CustomAttribute.Decimal(ErrorMessage = Common.Constant.InnovationDetailErrorCode.ErrorMessageNumber)]
        public decimal TSLGFundsSecured { get; set; }

        [CustomAttribute.Decimal(ErrorMessage = Common.Constant.InnovationDetailErrorCode.ErrorMessageNumber)]
        public decimal TfLFundsSecured { get; set; }

        [CustomAttribute.Decimal(ErrorMessage = Common.Constant.InnovationDetailErrorCode.ErrorMessageNumber)]
        public decimal RIAFundsSecured { get; set; }

        [CustomAttribute.Decimal(ErrorMessage = Common.Constant.InnovationDetailErrorCode.ErrorMessageNumber)]
        public decimal BISFundsSecured { get; set; }

        [StringLength(2000, ErrorMessage = Common.Constant.InnovationDetailErrorCode.ErrorMessageMaximumLength)]
        public string FundingComments { get; set; }

        public bool? IsIncifAuthoritytoProceed { get; set; }

        [StringLength(32, ErrorMessage = Common.Constant.InnovationDetailErrorCode.ErrorMessageMaximumLength)]
        public string IncifPurchaseOrderNumber { get; set; }

        [CustomAttribute.Decimal(ErrorMessage = Common.Constant.InnovationDetailErrorCode.ErrorMessageNumber)]
        public decimal IncifMaximumValueofWork { get; set; }

        [StringLength(245, ErrorMessage = Common.Constant.InnovationDetailErrorCode.ErrorMessageMaximumLength)]
        public string IncifDelegatedAuthorityName { get; set; }

        [StringLength(128, ErrorMessage = Common.Constant.InnovationDetailErrorCode.ErrorMessageMaximumLength)]
        public string IncifDelegatedAuthorityTitle { get; set; }

        [StringLength(128, ErrorMessage = Common.Constant.InnovationDetailErrorCode.ErrorMessageMaximumLength)]
        public string IncifDelegatedAuthorityContactNumber { get; set; }

        public string IncifDelegatedAuthorityDate { get; set; }

        [StringLength(32, ErrorMessage = Common.Constant.InnovationDetailErrorCode.ErrorMessageMaximumLength)]
        public string ICSCRef { get; set; }

        public string DateofICSC { get; set; }

        public bool? IsICSCAuthoritytoProceed { get; set; }

        [StringLength(32, ErrorMessage = Common.Constant.InnovationDetailErrorCode.ErrorMessageMaximumLength)]
        public string IARef { get; set; }

        public string DateofIA { get; set; }


        public bool? IsIAAuthoritytoProceed { get; set; }


        [CustomAttribute.Decimal(ErrorMessage = Common.Constant.InnovationDetailErrorCode.ErrorMessageNumber)]
        public decimal IAMaximumValueofWork { get; set; }

        public bool? IsExternalAuthoritytoProceed { get; set; }

        [StringLength(32, ErrorMessage = Common.Constant.InnovationDetailErrorCode.ErrorMessageMaximumLength)]
        public string ExternalRef { get; set; }

        [CustomAttribute.Decimal(ErrorMessage = Common.Constant.InnovationDetailErrorCode.ErrorMessageNumber)]
        public decimal ExternalMaximumValueofWork { get; set; }

        [StringLength(256, ErrorMessage = Common.Constant.InnovationDetailErrorCode.ErrorMessageMaximumLength)]
        public string ExternalDelegatedAuthorityName { get; set; }

        [StringLength(128, ErrorMessage = Common.Constant.InnovationDetailErrorCode.ErrorMessageMaximumLength)]
        public string ExternalDelegatedAuthorityTitle { get; set; }

        [StringLength(128, ErrorMessage = Common.Constant.InnovationDetailErrorCode.ErrorMessageMaximumLength)]
        public string ExternalDelegatedAuthorityContactNumber { get; set; }

        public string ExternalDelegatedAuthorityDate { get; set; }

        [StringLength(2000, ErrorMessage = Common.Constant.InnovationDetailErrorCode.ErrorMessageMaximumLength)]
        public string ExternalFundingComments { get; set; } 
        #endregion

        #region Fields Permission

        public bool HasWriteOnExpenditureToDate { get; set; }
        public bool HasWriteOnTotalAuthorisedInvestment { get; set; }
        public bool HasWriteOnCRLAuthorisedInvestment { get; set; }
        public bool HasWriteOnTSLGFundsSecured { get; set; }
        public bool HasWriteOnTfLFundsSecured { get; set; }
        public bool HasWriteOnRIAFundsSecured { get; set; }
        public bool HasWriteOnBISFundsSecured { get; set; }
        public bool HasWriteOnFundingComments { get; set; }
        public string HasWriteOnIncifAuthoritytoProceed { get; set; }
        public bool HasWriteOnIncifPurchaseOrderNumber { get; set; }
        public bool HasWriteOnIncifMaximumValueofWork { get; set; }
        public bool HasWriteOnIncifDelegatedAuthorityName { get; set; }
        public bool HasWriteOnIncifDelegatedAuthorityTitle { get; set; }
        public bool HasWriteOnIncifDelegatedAuthorityContactNumber { get; set; }
        public bool HasWriteOnIncifDelegatedAuthorityDate { get; set; }
        public bool HasWriteOnICSCRef { get; set; }
        public bool HasWriteOnDateofICSC { get; set; }
        public string HasWriteOnICSCAuthoritytoproceed { get; set; }
        public bool HasWriteOnIARef { get; set; }
        public bool HasWriteOnDateofIA { get; set; }
        public string HasWriteOnIAAuthoritytoProceed { get; set; }
        public bool HasWriteOnIAMaximumValueofWork { get; set; }
        public string HasWriteOnExternalAuthoritytoProceed { get; set; }
        public bool HasWriteOnExternalRef { get; set; }
        public bool HasWriteOnExternalMaximumValueofWork { get; set; }
        public bool HasWriteOnExternalDelegatedAuthorityName { get; set; }
        public bool HasWriteOnExternalDelegatedAuthorityTitle { get; set; }
        public bool HasWriteOnExternalDelegatedAuthorityContactNumber { get; set; }
        public bool HasWriteOnExternalDelegatedAuthorityDate { get; set; }
        public bool HasWriteOnExternalFundingComments { get; set; }

        #endregion

        #region Convert method
        public static InnovationFinancial ConvertToInnovationFinancialEntity(InnovationFinancialsModel innovation)
        {
            InnovationFinancial entity = new InnovationFinancial()
            {
                ID = innovation.ID,
                InnovationRef = innovation.InnovationRef,
                ExpenditureToDate = null,
                TotalAuthorisedInvestment = innovation.TotalAuthorisedInvestment,
                CRLAuthorisedInvestment = innovation.CRLAuthorisedInvestment,
                TSLGFundsSecured = innovation.TSLGFundsSecured,
                TfLFundsSecured = innovation.TfLFundsSecured,
                RIAFundsSecured = innovation.RIAFundsSecured,
                BISFundsSecured = innovation.BISFundsSecured,
                FundingComments = CommonUtil.TrimString(innovation.FundingComments),
                IsIncifAuthoritytoProceed = innovation.IsIncifAuthoritytoProceed,
                IncifPurchaseOrderNumber = innovation.IncifPurchaseOrderNumber,
                IncifMaximumValueofWork = innovation.IncifMaximumValueofWork,
                IncifDelegatedAuthorityName = CommonUtil.TrimString(innovation.IncifDelegatedAuthorityName),
                IncifDelegatedAuthorityTitle = CommonUtil.TrimString(innovation.IncifDelegatedAuthorityTitle),
                IncifDelegatedAuthorityContactNumber = CommonUtil.TrimString(innovation.IncifDelegatedAuthorityContactNumber),
                ICSCRef = CommonUtil.TrimString(innovation.ICSCRef),
                IsICSCAuthoritytoProceed = innovation.IsICSCAuthoritytoProceed,
                IARef = CommonUtil.TrimString(innovation.IARef),
                IsIAAuthoritytoProceed = innovation.IsIAAuthoritytoProceed,
                IAMaximumValueofWork = innovation.IAMaximumValueofWork,
                IsExternalAuthoritytoProceed = innovation.IsExternalAuthoritytoProceed,
                ExternalRef = CommonUtil.TrimString(innovation.ExternalRef),
                ExternalMaximumValueofWork = innovation.ExternalMaximumValueofWork,
                ExternalDelegatedAuthorityName = CommonUtil.TrimString(innovation.ExternalDelegatedAuthorityName),
                ExternalDelegatedAuthorityTitle = CommonUtil.TrimString(innovation.ExternalDelegatedAuthorityTitle),
                ExternalDelegatedAuthorityContactNumber = CommonUtil.TrimString(innovation.ExternalDelegatedAuthorityContactNumber),
                ExternalFundingComments = !String.IsNullOrEmpty(innovation.ExternalFundingComments) ? innovation.ExternalFundingComments.Trim() : null,
                ExternalDelegatedAuthorityDate = CommonUtil.ParseDate(innovation.ExternalDelegatedAuthorityDate),
                DateofIA = CommonUtil.ParseDate(innovation.DateofIA),
                DateofICSC = CommonUtil.ParseDate(innovation.DateofICSC),
                IncifDelegatedAuthorityDate = CommonUtil.ParseDate(innovation.IncifDelegatedAuthorityDate)
            };
            if (innovation.ExpenditureToDate != 0)
            {
                entity.ExpenditureToDate = innovation.ExpenditureToDate;
            }
            return entity;
        }

        public static InnovationFinancialsModel ConvertToInnovationFinancialsModel(InnovationFinancial innovation)
        {
            var innovationFinancial = new InnovationFinancialsModel();

            innovationFinancial.ID = innovation.ID;
            innovationFinancial.Innovation = innovation.Innovation;
            innovationFinancial.InnovationRef = innovation.InnovationRef;
            innovationFinancial.ExpenditureToDate = innovation.ExpenditureToDate.HasValue ? innovation.ExpenditureToDate.Value : 0;
            innovationFinancial.TotalAuthorisedInvestment = innovation.TotalAuthorisedInvestment;
            innovationFinancial.CRLAuthorisedInvestment = innovation.CRLAuthorisedInvestment;
            innovationFinancial.TSLGFundsSecured = innovation.TSLGFundsSecured;
            innovationFinancial.TfLFundsSecured = innovation.TfLFundsSecured;
            innovationFinancial.RIAFundsSecured = innovation.RIAFundsSecured;
            innovationFinancial.BISFundsSecured = innovation.BISFundsSecured;
            innovationFinancial.FundingComments = innovation.FundingComments;
            innovationFinancial.IsIncifAuthoritytoProceed = innovation.IsIncifAuthoritytoProceed;
            innovationFinancial.IncifPurchaseOrderNumber = innovation.IncifPurchaseOrderNumber;
            innovationFinancial.IncifMaximumValueofWork = innovation.IncifMaximumValueofWork;
            innovationFinancial.IncifDelegatedAuthorityName = innovation.IncifDelegatedAuthorityName;
            innovationFinancial.IncifDelegatedAuthorityTitle = innovation.IncifDelegatedAuthorityTitle;
            innovationFinancial.IncifDelegatedAuthorityContactNumber = innovation.IncifDelegatedAuthorityContactNumber;
            innovationFinancial.ICSCRef = innovation.ICSCRef;
            innovationFinancial.IsICSCAuthoritytoProceed = innovation.IsICSCAuthoritytoProceed;
            innovationFinancial.IARef = innovation.IARef;
            innovationFinancial.IsIAAuthoritytoProceed = innovation.IsIAAuthoritytoProceed;
            innovationFinancial.IAMaximumValueofWork = innovation.IAMaximumValueofWork;
            innovationFinancial.IsExternalAuthoritytoProceed = innovation.IsExternalAuthoritytoProceed;
            innovationFinancial.ExternalRef = innovation.ExternalRef;
            innovationFinancial.ExternalMaximumValueofWork = innovation.ExternalMaximumValueofWork;
            innovationFinancial.ExternalDelegatedAuthorityName = innovation.ExternalDelegatedAuthorityName;
            innovationFinancial.ExternalDelegatedAuthorityTitle = innovation.ExternalDelegatedAuthorityTitle;
            innovationFinancial.ExternalDelegatedAuthorityContactNumber = innovation.ExternalDelegatedAuthorityContactNumber;
            innovationFinancial.ExternalFundingComments = innovation.ExternalFundingComments;
            innovationFinancial.ExternalDelegatedAuthorityDate = CommonUtil.ParseDateToString(innovation.ExternalDelegatedAuthorityDate);
            innovationFinancial.DateofIA = CommonUtil.ParseDateToString(innovation.DateofIA);
            innovationFinancial.DateofICSC = CommonUtil.ParseDateToString(innovation.DateofICSC);
            innovationFinancial.IncifDelegatedAuthorityDate = CommonUtil.ParseDateToString(innovation.IncifDelegatedAuthorityDate);

            return innovationFinancial;
        }
        #endregion
    }
}