﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data.SqlTypes;
using System.Linq;
using System.Web;

namespace Crossrail.IMS.WebApp.Models
{
	public class InnovationModel
	{
        public int ID { get; set; }

        [DisplayName("Reference Number")]
        public string InnovationRef { get; set; }

        [DisplayName("Innovation Title")]
        public string InnovationTitle { get; set; }

        [DisplayName("Proposing Site / Project / Directorate")]
        public string ProposingItem { get; set; }

        [DisplayName("Theme")]
        public string ThemeName { get; set; }

        [DisplayName("SubTheme")]
        public string SubThemeName { get; set; }

        [DisplayName("Current IRL")]
        public string CurrentIRLName { get; set; }

        [DisplayName("Current Stage")]
        public string CurrentStage { get; set; }

        [DisplayName("Submitted For Competition Date")]
        public DateTime SubmittedForCompetitionDate { get; set; }

	    [DisplayName("Submitted For Competition Date")]
	    public DateTime? NullableSubmittedForCompetitionDate
	    {
	        get
	        {
                if (SubmittedForCompetitionDate == SqlDateTime.MinValue.Value)
                    return null;

	            return SubmittedForCompetitionDate;
	        }
	    }

        [DisplayName("Next Steps")]
        public string NextSteps { get; set; }

        [DisplayName("Next Steps")]
	    public string NextStepsDisplayString
	    {
	        get
	        {
                if (string.IsNullOrEmpty(NextSteps))
                    return string.Empty;

                if (NextSteps.Length > 100)
                    return HttpUtility.HtmlEncode(NextSteps.Substring(0, 100));

	            return HttpUtility.HtmlEncode(NextSteps);
	        }
	    }

	    public bool CanViewMoreContentOnNextSteps
	    {
	        get { return !string.IsNullOrEmpty(NextSteps) && NextSteps.Length > 100; }
	    }

		
	}
}