﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;
using Crossrail.IMS.WebApp.DataGatewayService;


namespace Crossrail.IMS.WebApp.Models
{
	public class LinkedDocumentModel
	{
		public int ID { get; set; }

        [UIHint("Attachment")]
		public string DocumentPath { get; set; }

        [StringLength(500, ErrorMessage = Common.Constant.InnovationDetailErrorCode.ErrorMessageMaximumLength)]
        public string DocumentURL { get; set; }

		[StringLength(500, ErrorMessage = Common.Constant.InnovationDetailErrorCode.ErrorMessageMaximumLength)]
		public string DocumentDescription { get; set; }

		public DateTime? CreatedDate { get; set; }

		public int Innovation_ID { get; set; }

		public string DownloadLink { get; set; }

		public string InnovationRef { get; set; }

		public bool? IsNew { get; set; }

		public bool? IsDeleted { get; set; }

        public Guid TemptId { get; set; }

        public static LinkedDocumentsTemporary ConvertToLinkedDocumentEntity(LinkedDocumentModel data)
        {
            return new LinkedDocumentsTemporary()
            {
                ID = data.ID,
                DocumentPath = data.DocumentPath != null ? data.DocumentPath.Trim() : null,
                DocumentURL = data.DocumentURL != null ? data.DocumentURL.Trim() : null,
                DocumentDescription = data.DocumentDescription != null ? data.DocumentDescription.Trim() : null,
                TemptId = data.TemptId,
                Innovation = new Innovation() { ID = data.Innovation_ID },
            };
        }
	}
}