﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Crossrail.IMS.Common;

namespace Crossrail.IMS.WebApp.Models
{
    public class SearchInnovationModel
    {
        #region ctors

        #endregion

        #region Datasources
        public List<SelectListItem> ProposingItems { get; set; }
        public List<SelectListItem> Themes { get; set; }
        public List<SelectListItem> SubThemes { get; set; }
        public List<SelectListItem> CurrentIRLs { get; set; }
        public List<SelectListItem> CurrentStages { get; set; }
        #endregion

        #region Search criteria
        [DisplayName("Reference Number")]
        [AllowHtml]
        [StringLength(8, ErrorMessage = Common.Constant.InnovationDetailErrorCode.ErrorMessageMaximumLength)]
        public string InnovationReference { get; set; }

        [DisplayName("Proposing Site/Project/Directorate")]
        public int? ProposingItem { get; set; }

        [DisplayName("Sub Theme")]
        public int? SubTheme { get; set; }

        [DisplayName("Current Stage")]
        public int? CurrentStage { get; set; }

        [DisplayName("Innovation Title")]
        [AllowHtml]
        [StringLength(256, ErrorMessage = Common.Constant.InnovationDetailErrorCode.ErrorMessageMaximumLength)]
        public string InnovationTitle { get; set; }

        [DisplayName("Theme")]
        public int? Theme { get; set; }

        [DisplayName("Current IRL")]
        public int? CurrentIRL { get; set; }

        [DisplayName("From")]
        public DateTime? SubmittedForCompetitionDateFrom { get; set; }

        [DisplayName("To")]
        public DateTime? SubmittedForCompetitionDateTo { get; set; }

        [DisplayName("Search Text")]
        [AllowHtml]
        public string SearchText { get; set; }

        public SearchInnovationMode SearchMode { get; set; }

        #endregion

        #region Result
        public IEnumerable<InnovationModel> SearchResult { get; set; }
        #endregion
    }
}