﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;
using System.Web.Helpers;
using System.Web.Mvc;
using Crossrail.IMS.Common;

namespace Crossrail.IMS.WebApp.Models
{
    public enum UserManagementMode
    {
        Add,
        Edit
    }

    public class UserDetailsModel
    {
        public int UserID { get; set; }

        [Required(ErrorMessage = "The Role field is required.")]
        public int? RoleID { get; set; }

        [Required(ErrorMessage = "The UserName field is required.")]
        [StringLength(20, ErrorMessage = "The UserName cannot be longer than 20 characters.")]
        public string UserName { get; set; }

        public List<SelectListItem> Roles { get; set; }

        public List<SelectListItem> ADUsers { get; set; }

        public List<ActiveDirectoryUser> Users { get; set; }

        public List<ProposingItem> ProposingItems { get; set; }

        public List<ProposingItem> ChampionFors { get; set; }
        
        [DisplayName("Disabled")]
        public bool IsDisabled { get; set; }

        public string FullName { get; set; }

        public string Email { get; set; }

        public string ContactNumber { get; set; }

        public UserManagementMode Mode { get; set; }

        public UserDetailsModel()
        {
            
        }

        public UserDetailsModel(UserManagementMode mode)
        {
            this.Mode = mode;
        }
    }

}