﻿using System;
using System.ComponentModel.DataAnnotations;

public class CustomAttribute
{
    [AttributeUsage(AttributeTargets.Property, AllowMultiple = false)]
    public class DecimalAttribute : DataTypeAttribute
    {
        public DecimalAttribute()
            : base("digits")
        {
        }



        public override string FormatErrorMessage(string name)
        {
            return base.FormatErrorMessage(string.Empty);
        }

        public override bool IsValid(object value)
        {
            if (value == null) return true;

            decimal retNum;

            var parseSuccess = decimal.TryParse(Convert.ToString(value), out retNum);

            return parseSuccess && retNum >= 0;
        }
    }
}